/*
error.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/

#include "config.h"
#include "mainwin.h"
#include "bhintl.h"
#include <bhmsgbox.h>

extern bhpos::widget::bhmsgbox *msgbox;

void mainwin::SystemErrMsg(int e, void *d)
{
   int x, y, bt, cdr;
   char          id[255];
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   eng->GetOption(MFENG_CONFIG_DISP_XSIZE, &x);
   eng->GetOption(MFENG_CONFIG_DISP_YSIZE, &y);
   eng->GetOption(MFENG_CONFIG_CASHDRESETTLOGIN, &cdr);
   
   switch(e){
   case bhmfengine::BHMF_EVENT_LOGIN:
      x=3;
      eng->Command(bhmfengine::BHMF_CMD_SYSTEM_BEEP, &x);
      break;
   
   case bhmfengine::BHMF_EVENT_LOGOUT:
      break;
   }
}

void mainwin::TransactionErrMsg(int e, void *d)
{
   int i;
   
   switch(e){
   case bhmfengine::BHMF_EVENT_TRANS_ID:
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_RETURN:
      //CurrPluLookup=*((bhpos::CSaleItem *) d);
      eng->GetOption(MFENG_CONFIG_UPLUPOLICY, &i);
      if(i==0){
         CurrPluLookup.SetType(bhpos::BHSI_SITYPE_PRICE);
      }
      if(i==1){
         CurrPluLookup.SetType(bhpos::BHSI_SITYPE_DESCPRICE);
      }
      if(i==2){
         CurrPluLookup.SetType(bhpos::BHSI_SITYPE_UPLU);
      }
      CurrPluLookup.SetDispText(_("Unknown Item"));
      CurrPluLookup.SetRecText(_("Item"));
      CurrPluLookup.SetPrice(0); 
      CurrPluLookup.SetFlags(0); 
      //g_print("fucknuts");
      //post_signal.emit(BhPos::BHTRANS_PROCTYPE_SITEM, &CurrPluLookup);
      //trans->Process(BhPos::BHTRANS_PROCTYPE_SITEM, &CurrPluLookup);
      if(d==NULL) return;
      saleitems->Add(bhpos::widget::BHITEMLIST_ITEMFLAG_NONE, (bhpos::CSaleItem *) d);
      break;
      
   case bhmfengine::BHMF_EVENT_TRANS_VOID:
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_END:
      break;
   }
}


bool mainwin::LoginRefuseTimer()
{
   static int beep=0;
   Gdk::Color col;
   int        x=2;
   
   beep++;
   if(beep==1){
      statusbar->SetText(bhpos::widget::BHSTATUS_USER, _("Error"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Log In Error"));
      col.set_rgb(65535, 0, 0);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      col.set_rgb(65535, 65535, 65535);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      eng->Command(bhmfengine::BHMF_CMD_SYSTEM_BEEP, &x);
      return true;
   }
   else if(beep==2){
      statusbar->SetText(bhpos::widget::BHSTATUS_USER, _("Login to Start"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Logged Out"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      col.set_rgb(65535, 65535, 65535);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      timer_slot.disconnect();
   }
   return false;
}

void mainwin::PosErrMsg(int e, void *d)
{
   switch(e){
   case bhmfengine::BHMF_EVENT_LOGIN:
      //g_print("login error\n");
      sigc::slot<bool> slot = sigc::mem_fun(*this, &mainwin::LoginRefuseTimer);
      timer_slot = Glib::signal_timeout().connect(slot, 750);
      break;
   }
}
