/*
hardware.cpp
Copyright (C) 2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include <bhintl.h>
#include "mainwin.h"

void mainwin::HardwareMsg(int e, void *d)
{
   int x, y, bm, bt, cdr;
   Gdk::Color col;
   char buff[128];
   
   eng->GetOption(MFENG_CONFIG_MODAL, &bm);
   eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   eng->GetOption(MFENG_CONFIG_DISP_XSIZE, &x);
   eng->GetOption(MFENG_CONFIG_DISP_YSIZE, &y);
   eng->GetOption(MFENG_CONFIG_CASHDRESETTLOGIN, &cdr);
   
   switch(e){
   case bhmfengine::BHMF_EVENT_HW_CASHDRAWERCLOSED:
      // kill timer
      // revert 
      cdtimer_slot.disconnect();
      eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_IDLE, NULL);
      if(bt){
         setstatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
      }
      else{
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      cleartrans();
      int    num_trans;
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMTRANS, 0, &num_trans);
      if(num_trans==0){
         sprintf(buff, _("Sale - No Open Transactions"));
      }
      else if(num_trans==1){
         sprintf(buff, _("Sale - 1 Open Transaction"));
      }
      else{
         sprintf(buff, _("Sale - %d Open Transactions"), num_trans);
      }
      set_title(buff);
      eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_CLEAR, NULL);
      eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_POST, NULL);
      //statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, "Waiting on Trans");
      //col.set_rgb(65535, 0, 0);
      //statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      break;
   /*
   case bhmfengine::BHMF_EVENT_HW_CASHDRAWEROPEN:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, "Close Drawer");
      col.set_rgb(65535, 0, 0);
      statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      break;*/
   
   case bhmfengine::BHMF_EVENT_HW_WAITINGONSWIPE:
      setstatus(bhmfengine::MF_STATUS_MAGWAIT);
      break;
   
   case bhmfengine::BHMF_EVENT_HW_WAITINGONSMART:
      setstatus(bhmfengine::MF_STATUS_SMARTWAIT);
      break;
   
   case bhmfengine::BHMF_EVENT_HW_CHEQUELOAD:
      setstatus(bhmfengine::MF_STATUS_CHEQUEPRNWAIT);
      eng->Command(bhmfengine::BHMF_CMD_HW_PRINTER_CHQPRINT, NULL);
      break;
   case bhmfengine::BHMF_EVENT_HW_CHEQUECANCELED:
      g_print("checque cancelled \n");
      break;
   }
}
void mainwin::HardwareErrorMsg(int e, void *d)
{
   switch(e){
   case bhmfengine::BHMF_EVENT_HWERROR_BCADD:
   case bhmfengine::BHMF_EVENT_HWERROR_BCOPEN:
   case bhmfengine::BHMF_EVENT_HWERROR_BCDEVICE:
   case bhmfengine::BHMF_EVENT_HWERROR_PRINTERADD:
   case bhmfengine::BHMF_EVENT_HWERROR_PRINTEROPEN:
      break;
   }
   /*
      //   ct=manage(new confirm(BHCONFIRMBOX_OK, _("Hardware Error"),				
		//		"icon_printererr.png",
		//		_("A printer was speficied in the configure file, yet none was found."),
		//		NULL,
		//		NULL));
   */
}
