/*
keyevent.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include <bhintl.h>
#include <bhmsgbox.h>
#include <bhpaybox.h>
#include <bhselbox.h>
#include "mainwin.h"

bhpos::widget::bhmsgbox *msgbox;
bhpos::widget::bhpaybox *paybox;
bhpos::widget::bhselbox *selbox;

void mainwin::on_msgbox_event(int event)
{
   switch(dialoguestatus){
   case BHDB_STATUS_CANCELTRANS:
      if(event==0){
         return;
      }
      else{
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Voiding Trans"));
         eng->Command(bhmfengine::BHMF_CMD_TRANS_VOID, 0);
      }
      break;
   
   case BHDB_STATUS_LOGOUT:
   {
      bool b, bb, bz, br;
   
      if(event){
         eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &b);
         eng->GetOption(MFENG_CONFIG_BLINDBALATLOGOUT, &bb);
         eng->GetOption(MFENG_CONFIG_ZTAPEATLOGOUT, &bz);
         eng->GetOption(MFENG_CONFIG_CASHDRESETTLOGIN, &br);
   
         if(!b &  bb){
            // let's blind balance
            //set_title(_("Blind Balance"));
            setstatus(bhmfengine::MF_STATUS_BLINDBALANCEFETCH);
   	      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Retrieving Balance"));
	         eng->Command(bhmfengine::BHMF_CMD_SYSTEM_BLINDBALANCE, 0);
            return;
         }
         if(bz){
            eng->Command(bhmfengine::BHMF_CMD_SYSTEM_ZTAPE, NULL);
         }
         eng->Command(bhmfengine::BHMF_CMD_LOGOUT, NULL);
      }
   }
      break;
   
   case BHDB_STATUS_LOGOUTP:
      if(event)
         logout();   
      break;
   
   case BHDB_STATUS_QUIT:
      if(event){
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Disconnecting..."));
         eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_CLEAR, NULL);
         eng->Command(bhmfengine::BHMF_CMD_DISCONNECT, NULL);
      }
      break;
      
   case BHDB_STATUS_LOADCHEQUE:
      if(event){
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Cancelling Cheque"));
         //eng->Command(bhmfengine::BHMF_CMD_DISCONNECT, NULL);
      }
      break;
      
   case BHDB_STATUS_LOADSLIP:
   case BHDB_STATUS_PRINTING:
      break;
   
   case BHDB_STATUS_CREDITSEIZE:
   case BHDB_STATUS_CREDITFAIL:
      break;
   
   case BHDB_STATUS_CREDITERROR:
      if(event){  // retry
      }
      break;
   }
}

void mainwin::on_paybox_event(int event, float amount)
{
   Gdk::Color col;
   
   switch(dialoguestatus){
   case BHDB_STATUS_PAYIN:
      if(event){
         eng->Command(bhmfengine::BHMF_CMD_SYSTEM_PAYIN, &amount);
      }
      else{
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      break;
   case BHDB_STATUS_PAYOUT:
      if(event){
         eng->Command(bhmfengine::BHMF_CMD_SYSTEM_PAYOUT, &amount);
      }
      else{
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      break;
   }
}

void mainwin::on_selbox_event(int event, void *v)
{
   Gdk::Color col;
   
   switch(dialoguestatus){
   case BHDB_STATUS_SELLPRICE:
      if(event){
         //eng->Command(bhmfengine::BHMF_CMD_SYSTEM_PAYIN, &amount);
      }
      else{
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      break;
      
   case BHDB_STATUS_SELTAX:
      if(event){
         //eng->Command(bhmfengine::BHMF_CMD_SYSTEM_PAYIN, &amount);
      }
      else{
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      break;
   }
}

bool mainwin::KeyReleaseEvent(GdkEventKey *ev)
{
   char   id[255];
   int    num_trans, num_items, ret, num_pay;
   bool   bConfirm, bt;
   double a;
   Gdk::Color col;
   
   strcpy(id, "");
   
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTNUMITEMS, 0, &num_items);
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMPAYITEMS, 0, &num_pay);
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMTRANS, 0, &num_trans);
   eng->GetOption(MFENG_CONFIG_CONFIRMPOLICY, &bConfirm);
   eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   
   Glib::ustring          txt=gdk_keyval_name(ev->keyval);
   bhmfengine::BhMfStatus status=eng->GetStatus();
   
   /*
   if(eng->KeyEvent(ev)){   // key consumed
      g_print(" - consumed - \n");
      return true;
   }
   */
   if(ev->state & GDK_CONTROL_MASK){
		if((ret=KeyControl(ev))) return ret;
	}
	
	if(ev->state & GDK_SHIFT_MASK){
	   if((ret=KeyShift(ev))) return ret;
   }

   switch(ev->keyval){
   case GDK_Escape:
      //g_print("keyevent: %d \n", status);
      switch(status){
      case bhmfengine::MF_STATUS_LOGGEDOUT:
      case bhmfengine::MF_STATUS_PASSIVELOGOUT:
         if(num_trans==0){
            eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
            strcat(id, "/sb_exit.png");
            dialoguestatus=BHDB_STATUS_QUIT;
            msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_YESNO, _("Quit Application"),id, _("Quit?"));
            msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
         }
         break;
      
      case bhmfengine::MF_STATUS_LOGGEDIN:
         if(bt){
            dialoguestatus=BHDB_STATUS_LOGOUTP;
         }
         else{
            dialoguestatus=BHDB_STATUS_LOGOUT;
         }
         if(bConfirm){
            eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
            strcat(id, "/sb_logout.png");
            msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_YESNO, _("Log Out"),id, _("Log Out?"));
            msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
         }
         else{
            logout();
         }
         break;
      
      case bhmfengine::MF_STATUS_IDLE:
         if(num_items <= 0){
            if(bt){
               dialoguestatus=BHDB_STATUS_LOGOUTP;
            }
            else{
               dialoguestatus=BHDB_STATUS_LOGOUT;
            }
            if(bConfirm){
               eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
               strcat(id, "/sb_logout.png");
               msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_YESNO, _("Log Out"),id, _("Log Out?"));
               msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
            }
            else{
               logout();
            }
         }
         else{
            // cancel trans
            dialoguestatus=BHDB_STATUS_CANCELTRANS;
            eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
            strcat(id, "/sb_canceltrans.png");
            msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_YESNO, _("Cancel Transaction"),id, _("Cancel Transaction"));
            msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
         }
         break;
      
      case bhmfengine::MF_STATUS_PLUWAIT:
         //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_SELPLU, &txt);
         // clear current buff
         //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
         setstatus(bhmfengine::MF_STATUS_IDLE);
         break;
      
      case bhmfengine::MF_STATUS_QUANTITY:
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
         setstatus(bhmfengine::MF_STATUS_IDLE);
         break;
      
      case bhmfengine::MF_STATUS_UNKNOWNPLU:
      case bhmfengine::MF_STATUS_DESCRIPTIONENTRY:
      case bhmfengine::MF_STATUS_PRICEENTRY:
      case bhmfengine::MF_STATUS_CASHITEM:
         //g_print("vxretaill::keystroke::esc in edit\n");
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
         setstatus(bhmfengine::MF_STATUS_IDLE);
         break;
      
      case bhmfengine::MF_STATUS_SCANREMOVE:
         setstatus(bhmfengine::MF_STATUS_IDLE);
         break;
         
      
      case bhmfengine::MF_STATUS_TRANS:
         // trans id looks to have failed...
         break;
      
      case bhmfengine::MF_STATUS_PLULOOKUPNA:
         bPluLookup=false;
         setstatus(bhmfengine::MF_STATUS_IDLE);
         // cancel lookup
         break;
      
      case bhmfengine::MF_STATUS_LISTEDIT:
         //cancel editing...
         saleitems->Navigation(bhpos::widget::BHNAV_TYPE_END);
         setstatus(bhmfengine::MF_STATUS_IDLE);
         break;
      
      case bhmfengine::MF_STATUS_PRICELIST:
         setstatus(bhmfengine::MF_STATUS_IDLE);
         saleitems->PriceList(NULL, false);
         break;
      
      case bhmfengine::MF_STATUS_TENDER:
         if(num_pay==0){
            saleitems->PayMode(0.0, false);
            setstatus(bhmfengine::MF_STATUS_IDLE);
            return true;
         }
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEARALLPAYMENT, NULL);
         eng->Command(bhmfengine::BHMF_CMD_PITEM_REMOVEALL, NULL);
         transdetail->SetText(bhpos::widget::BHTRANDETAIL_TENDERED, "");
         setstatus(bhmfengine::MF_STATUS_TENDER);
         break;
      
      case bhmfengine::MF_STATUS_PAYTYPE:
         // remove all paytypee - for now:
         // FIX ME: just remove current in split, and item from transaction
         //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEARALLPAYMENT, NULL);
         //eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_TOTAL, NULL);
         //setstatus(bhmfengine::MF_STATUS_TENDER);
         return true;
         
      
      case bhmfengine::MF_STATUS_PAYEDIT:
         break;
      /*
      case bhmfengine::MF_STATUS_PAYAMOUNT:
         saleitems->SetMode(bhpos::widget::BHITEMLIST_MODE_SALE, NULL);
         setstatus(bhmfengine::MF_STATUS_IDLE);
         break;
      */
      case bhmfengine::MF_STATUS_CONFIRMCOMMIT:
         setstatus(bhmfengine::MF_STATUS_TENDER);
         break;
      
      case bhmfengine::MF_STATUS_MAGWAIT:
         setstatus(bhmfengine::MF_STATUS_TENDER);
         break;
   
      case bhmfengine::MF_STATUS_SMARTWAIT:
         setstatus(bhmfengine::MF_STATUS_TENDER);
         break;
   
      case bhmfengine::MF_STATUS_PAYAUTH:
         setstatus(bhmfengine::MF_STATUS_TENDER);
         break;
      }
      return true;
   
   case GDK_space: // general focus shifter
      if(status==bhmfengine::MF_STATUS_DESCRIPTIONENTRY){
      }
      else if(status==bhmfengine::MF_STATUS_PRICEENTRY){
      }
      return true;
   
   case GDK_KP_Enter:
   case GDK_Return:
      if(status==bhmfengine::MF_STATUS_PLUWAIT){
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_QUANTITY){
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_DESCRIPTIONENTRY){
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_PRICEENTRY){
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_CASHITEM){
         //g_print("nobber\n");
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_IDLE){   // total
         //g_print("return in idle\n");
         if(num_items > 0){
            setstatus(bhmfengine::MF_STATUS_TENDER);
            eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTAL, 0, &a);
            saleitems->SetMode(bhpos::widget::BHITEMLIST_MODE_TENDERTYPE, &a);
            eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_TOTAL, NULL);
         }
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_LISTEDIT){
         saleitems->Navigation(bhpos::widget::BHNAV_TYPE_END);
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      else if(status==bhmfengine::MF_STATUS_PAYTYPE){
         return true;
         //setstatus(bhmfengine::MF_STATUS_PAYTYPE);
         //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_PAYBALANCE, NULL);
      }
      else if(status==bhmfengine::MF_STATUS_PAYAMOUNT){
         return true;
         /*
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_PAYBALANCE, NULL);
         if(bConfirm){
            setstatus(bhmfengine::MF_STATUS_CONFIRMCOMMIT);
         }*/
      }
      else if(status==bhmfengine::MF_STATUS_CONFIRMCOMMIT){
         //return true;
         setstatus(bhmfengine::MF_STATUS_TRANSCOMMIT);
         eng->Command(bhmfengine::BHMF_CMD_TRANS_COMMIT, NULL);
      }
      return true;
      
   case GDK_F1:   // help
      break;
   
   case GDK_F2:   // sale type
   {
      //if(status!=bhmfengine::MF_STATUS_LOGGEDIN || status!=bhmfengine::MF_STATUS_IDLE) return true;
      BhPriceList plst;

      eng->GetList(bhmfengine::BHLISTTYPE_PRICE, &plst);
      setstatus(bhmfengine::MF_STATUS_IDLE);
         /*
      eng->SetStatus(bhmfengine::MF_STATUS_PRICELIST);
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Price List"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Select Price"));
      SmartBarStatus(BHSB_STATUS_CANCEL);*/
      
      saleitems->PriceList(&plst, true);
      return true;
      /*
      BhPriceListItem *plit=plst.item;
      bool bm;
      eng->GetOption(MFENG_CONFIG_MODAL, &bt);

      if(plst.num_items!=0){
         bhpos::widget::BhSelList pl;
         pl.num_items=plst.num_items;
         
         //pl.items=(bhpos::widget::BhSelItem *) calloc(plst.numitems, sizeof(bhpos::widget::BhSelItem));
         pl.items=new bhpos::widget::BhSelItem[plst.num_items];
         if(!pl.items){
            g_print("no alloc\n");
            return true;
         }
         bhpos::widget::BhSelItem *pli=pl.items;
         int n=plst.num_items;
         
         while(n){
            strcpy(pli->label, plit->name);
            g_print("sale label%d:%s - %s\n", n, pli->label, plit->name);
            pli++;
            plit++;
            n--;
         }

         eng->SetStatus(bhmfengine::MF_STATUS_PRICELIST);
         statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Price List"));
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Select Price"));
         dialoguestatus=BHDB_STATUS_SELLPRICE;
         strcat(id, "/sb_saleprice.png.png");
         selbox=new bhpos::widget::bhselbox("Sale Price Selection", id, "Select Sale Price", &pl);
         selbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_selbox_event));
         //selbox->show();
         delete [] pl.items;
         //saleitems->PriceList(&plst, true);
      }
      else{
         g_print("no sale type\n");
      }*/
   }
      return true;
   
   case GDK_F3:   // pay out
   {
      Glib::ustring buff, t, m; 
      
      dialoguestatus=BHDB_STATUS_PAYOUT;
      setstatus(bhmfengine::MF_STATUS_PAYOUT);
      t=_("Cash Drawer Adjutment");
      m=_("Pay Out");
      eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
      strcat(id, "/sb_payout.png");
      buff=id;
      paybox=new bhpos::widget::bhpaybox(bhpos::widget::BHPAYBOX_OUT, t,buff, m);
      paybox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_paybox_event));
   }
      return true;
   
   case GDK_F4:   // cycle trans
   {
      Gdk::Color col;
      char buff[32];
      bhpos::CTransItems ct;
      bhpos::BhTransactionType type;
      bhpos::BhTransStatus     status;
      ret=eng->TransCycle(ct);

      if(ret < -1){
         return true;
      }
      else if(ret==-1){
         transdetail->Clear();
         saleitems->Clear();
         banner->SetTotal(0.0);
         smartbar_status=BHSB_STATUS_NONE;
         bPluLookup=false;
         saleitems->Clear();
         transdetail->Clear();
         banner->SetTotal(0.0);
         setstatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
         SmartBarStatus(BHSB_STATUS_PASSSIVELOGOUT);
      }
      else{
         saleitems->Load(ct);
         statusbar->SetText(bhpos::widget::BHSTATUS_USER, ct.GetUserName());
         sprintf(buff, "%012d", ct.GetID());
         transdetail->SetText(bhpos::widget::BHTRANDETAIL_NUMBER, buff);
         statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Ready"));
         col.set_rgb(8704, 31744, 12288);
         statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
         type=ct.GetType();
         status=ct.GetStatus();
         switch(status){
         case bhpos::BHTRANS_STATUS_IDLE:
            setstatus(bhmfengine::MF_STATUS_IDLE);
            break;
         case bhpos::BHTRANS_STATUS_TOTAL:
            setstatus(bhmfengine::MF_STATUS_TENDER);
            break;
         case bhpos::BHTRANS_STATUS_TENDER:
            break;
         }
         updatetrans();
      }
   }
      return true;
   
   case GDK_F5:   // cash
      if(status==bhmfengine::MF_STATUS_IDLE){
         /*
         dialoguestatus=BHDB_STATUS_SELTAX;
         eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
         strcat(id, "/icon_tax.png");
         selbox=manage(new bhpos::widget::bhmsgbox(_("Tax Select"), id, _("Select Tax Rate")));
         selbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));*/
         eng->GetOption(MFENG_CONFIG_CASHSALE, &bt);
         if(!bt) return true;
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CASHITEM, NULL);
         setstatus(bhmfengine::MF_STATUS_CASHITEM);         
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_TENDER){
         saleitems->AddPayType(bhpos::PTYPE_CASH);
         setstatus(bhmfengine::MF_STATUS_PAYTYPE);
         //eng->SetStatus(bhmfengine::MF_STATUS_PAYTYPE);
         SmartBarStatus(BHSB_STATUS_PAYMENTSELECTED);
         eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_LINE2, (void *) "Cash :");
      }
      return true;
   
   case GDK_F6: // credit
   {
      eng->GetOption(MFENG_CONFIG_EXTERNCREDIT, &bt);
      saleitems->AddPayType(bhpos::PTYPE_CREDIT);
      setstatus(bhmfengine::MF_STATUS_PAYTYPE);
      SmartBarStatus(BHSB_STATUS_PAYMENTSELECTED);
      eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_LINE2, (void *) "Credit :");
   }
      return true;
   
   case GDK_F7: // cheque
      saleitems->AddPayType(bhpos::PTYPE_CHEQUE);
      setstatus(bhmfengine::MF_STATUS_PAYTYPE);
      SmartBarStatus(BHSB_STATUS_PAYMENTSELECTED);
      eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_LINE2, (void *) "Cheque :");
      return true;
   
   case GDK_F8: // smart card
   {
      eng->GetOption(MFENG_CONFIG_EXTERNCREDIT, &bt);
      saleitems->AddPayType(bhpos::PTYPE_SMARTC);
      setstatus(bhmfengine::MF_STATUS_PAYTYPE);
      SmartBarStatus(BHSB_STATUS_PAYMENTSELECTED);
      eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_LINE2, (void *) "Credit :");
   }
      return true;
      break;
   
   case GDK_F9:  // in-house charge
      break;
   
   case GDK_F10: //returns
      return true;
   
   case GDK_F11:  // plu lookup
      if(status==bhmfengine::MF_STATUS_IDLE){
         setstatus(bhmfengine::MF_STATUS_PLULOOKUPNA);
         bPluLookup=true;
         //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_PLULOOKUP, NULL);
         return true;
      }
      return true;
      
   case GDK_F12:  // remove
      if(status==bhmfengine::MF_STATUS_SCANREMOVE || num_items==0) return true;
      setstatus(bhmfengine::MF_STATUS_SCANREMOVE);
      eng->Command(bhmfengine::BHMF_CMD_SITEM_REMOVEBYSCAN,NULL);
      return true;
      
   case GDK_equal:
   case GDK_KP_Equal:
      SmartBarStatus(BHSB_STATUS_CANCEL);
      if(status==bhmfengine::MF_STATUS_IDLE){   // focus quantity
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_QTYNEW, NULL);
         setstatus(bhmfengine::MF_STATUS_QUANTITY);
      }
      else if(status==bhmfengine::MF_STATUS_QUANTITY){
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_QTYCHANGE, NULL);
         setstatus(bhmfengine::MF_STATUS_QUANTITY);
      }
      else if(status==bhmfengine::MF_STATUS_PLUWAIT){ //move number to quantity or move to edit
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Edit Quantity"));
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_QTYCHANGE, NULL);
         eng->SetStatus(bhmfengine::MF_STATUS_QUANTITY);
      }
      return true;
   
   
	case GDK_KP_Add:
   case GDK_plus:
      if(status==bhmfengine::MF_STATUS_IDLE || status==bhmfengine::MF_STATUS_LOGGEDIN){
         //g_print("idle\n");
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_INCNEW, NULL);
         eng->SetStatus(bhmfengine::MF_STATUS_QUANTITY);
      }
      else if(status==bhmfengine::MF_STATUS_QUANTITY){ 
         //g_print("qty\n");
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_INCMOVE, NULL);
      }
      else if(status==bhmfengine::MF_STATUS_PLUWAIT){ 
         //g_print("pluwait\n");
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_INCMOVE, NULL);
      }
      else if(status==bhmfengine::MF_STATUS_LISTEDIT){
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_INCEDIT, &CurrPluLookup);
      }
      return true;
      
	case GDK_KP_Subtract:		
	case GDK_minus:
      if(status==bhmfengine::MF_STATUS_IDLE){
         return true;
      }
      else if(status==bhmfengine::MF_STATUS_QUANTITY){ 
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_DECREMENT, NULL);
      }
      else if(status==bhmfengine::MF_STATUS_PLUWAIT){ 
         //g_print("pluwait\n");
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_INCMOVE, NULL);
      }
      else if(status==bhmfengine::MF_STATUS_LISTEDIT){
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_DECEDIT, &CurrPluLookup);
      }
      return true;
   
   
   case GDK_KP_Home:
   case GDK_Home:
	case GDK_KP_Up:
   case GDK_Up:
	case GDK_KP_Left:
   case GDK_Left:
	case GDK_KP_Right:
	case GDK_Right:
   case GDK_KP_Down:
	case GDK_Down:
   case GDK_KP_Page_Up:
	case GDK_Page_Up:
   case GDK_KP_Page_Down:
	case GDK_Page_Down:
   case GDK_KP_End:
	case GDK_End:
      SmartBarStatus(BHSB_STATUS_EDITMODE);
      return KeyNavigationEvent(ev, status);
   
   case GDK_Delete:
      return true;
   }
   
   if(status==bhmfengine::MF_STATUS_IDLE){
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Item Entry"));
      saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_NEW, &txt);
      // kludge a deselect...
      GdkEvent kev;
      memset(&kev, 0, sizeof(kev));
      kev.key.keyval=GDK_Right;
      kev.key.type=GDK_KEY_RELEASE;
      kev.any.window=NULL;
      gdk_event_put(&kev);
      eng->SetStatus(bhmfengine::MF_STATUS_PLUWAIT);
   }
   else if(status==bhmfengine::MF_STATUS_PLUWAIT){
      //statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Item Entry"));
      //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_SELPLU, &txt);
      return true;
   }
   else if(status==bhmfengine::MF_STATUS_QUANTITY){
      return true;
   }
   else if(status==bhmfengine::MF_STATUS_PRICEENTRY){
      return true;
   }
   else if(status==bhmfengine::MF_STATUS_CASHITEM){
      return true;
   }

   /*
   if(status==bhmfengine::MF_STATUS_LOGGEDOUT){
   }
   */
   return false;
}

bool mainwin::KeyNavigationEvent(GdkEventKey *ev, bhmfengine::BhMfStatus status)
{
   int num_items;

   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTNUMITEMS, 0, &num_items);
   
   if(status!=bhmfengine::MF_STATUS_IDLE && status!=bhmfengine::MF_STATUS_LISTEDIT){
      return true;
   }
   if(num_items==0){
      return true;
   }

   switch(ev->keyval){
   case GDK_KP_Home:
   case GDK_Home:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_HOME)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
	case GDK_KP_Up:
   case GDK_Up:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_UP)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
	case GDK_KP_Left:
   case GDK_Left:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_LEFT)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
	case GDK_KP_Right:
	case GDK_Right:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_RIGHT)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
   case GDK_KP_Down:
	case GDK_Down:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_DOWN)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
   case GDK_KP_Page_Up:
	case GDK_Page_Up:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_PGUP)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
   case GDK_KP_Page_Down:
	case GDK_Page_Down:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_PGDOWN)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
      
   case GDK_KP_End:
	case GDK_End:
      eng->SetStatus(bhmfengine::MF_STATUS_LISTEDIT);
      if(saleitems->Navigation(bhpos::widget::BHNAV_TYPE_END)){
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      return true;
   }
   
   //if(status!=bhmfengine::MF_STATUS_LISTEDIT){
   //}
   return false;
}

bool mainwin::KeyShift(GdkEventKey *ev)
{
   char          id[255];
   Glib::ustring buff, t, m; 
   Gdk::Color col;
   t=_("Cash Drawer Adjustment");
   m=_("Pay In");
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   
   switch(ev->keyval){
   case GDK_KP_Add:
   case GDK_plus:
      return false;
   
   case GDK_F1:   // clock in
   case GDK_F2:   // clock out
      break;
   
   case GDK_F3:   // pay in
      setstatus(bhmfengine::MF_STATUS_PAYIN);
      dialoguestatus=BHDB_STATUS_PAYIN;
      strcat(id, "/sb_payin.png");
      buff=id;
      paybox=manage(new bhpos::widget::bhpaybox(bhpos::widget::BHPAYBOX_IN, t,buff, m));
      paybox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_paybox_event));
      break;
   
   case GDK_F4:   // discreet discount
   case GDK_F5:   // cash back
   case GDK_F6:   // print z-tape
      break;
   }
   return true;
}

bool mainwin::KeyControl(GdkEventKey *ev)
{
   char          id[255];
   Glib::ustring buff, t, m; 
   Gdk::Color col;
   
   t=_("Cash Drawer Adjustment");
   m=_("Pay Adjustment");
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   
   switch(ev->keyval){
   case GDK_F3:   // pay adj
      dialoguestatus=BHDB_STATUS_PAYADJUSTMENT;
      strcat(id, "/icon_payadj.png");
      buff=id;
      paybox=new bhpos::widget::bhpaybox(bhpos::widget::BHPAYBOX_ADJUSTMENT, t, buff, m);
      paybox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_paybox_event));
      //paybox->show();
      break;
   
   case GDK_A:
   case GDK_a:
      break;
   }
   return true;
}
