/*
login.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/

#include "config.h"
#include "login.h"
#include <bhintl.h>
#include <bhmsgbox.h>

static bhpos::widget::bhmsgbox *errbox;

login::login(bhmfengine::CMfPosEngine *e) : login_ui(e)
{
   eng=e;
   litype=0;
   
   eng->signal_pos().connect(sigc::mem_fun(*this, &login::EngMsg));
   eng->signal_poserror().connect(sigc::mem_fun(*this, &login::EngErrMsg));
}

void login::EngMsg(int type, void *data)
{
   switch(type){
   case bhmfengine::BHMF_EVENT_LOGIN:
      break;
   }
}

void login::EngErrMsg(int type, void *data)
{
   char          id[255];
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   
   switch(type){
   case bhmfengine::BHMF_EVENT_LOGIN:
      strcat(id, "/icon_loginerror.png");
      errbox=manage(new class bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("Login Error"),id, _("Login Refused")));
      //errbox->signal_event().connect(sigc::mem_fun(*this, &mainwin_ui::on_errbox_event));
      break;
   }
}

void login::Close()
{
   this->destroy_();
}

bool login::on_login_delete_event(GdkEventAny *ev)
{
   g_print("delete event\n");
   return false;
}

bool login::KeyReleaseEvent(GdkEventKey *ev)
{
   return false;
}

void login::on_login_changed()
{  
}

void login::on_password_changed()
{  
}

void login::on_ok_clicked()
{
   Glib::ustring u,p;
   u=logint->get_text();
   p=password->get_text();
   if(u.size()==0) return;
   
   eng->Command(bhmfengine::BHMF_CMD_USERLOOKUP, NULL);
   /*
   if(litype==0){
      
      post->LoginEvent(BHLOGIN_TYPE_USERPASSWORD, u, p);
   }*/
}

void login::on_clear_clicked()
{  
   logint->set_text("");
   password->set_text("");
}

void login::on_login_activate()
{  
   litype=0;
}

void login::on_quit_activate()
{
   litype=1;
}

void login::on_options_changed()
{  
}
