/*
login_ui.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/
#include "config.h"
#include "bhintl.h"

#include "login_ui.h"
#include <gdk/gdkkeysyms.h>
#include <gtkmm/accelgroup.h>
#include <gtkmm/table.h>
#include <gtkmm/imagemenuitem.h>
#include <gtk/gtkimagemenuitem.h>
#include <gtkmm/menu.h>
#include <gtkmm/box.h>

LoginColumns::LoginColumns()
{ 
   add(icon); 
   add(name); 
}

login_ui::login_ui(bhmfengine::CMfPosEngine *eng) : Gtk::Window(Gtk::WINDOW_TOPLEVEL)
{  
   login = this;
   
   char id[255], imgfile[255];
   bool bModal;
   
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   eng->GetOption(MFENG_CONFIG_MODAL, &bModal);
   
   strcpy(imgfile, id);
   strcat(imgfile, "/banner1.png");
   
   Gtk::Image *banner = Gtk::manage(new class Gtk::Image(imgfile));
   label1 = Gtk::manage(new class Gtk::Label(_("Login")));
   label2 = Gtk::manage(new class Gtk::Label(_("Password")));
   logint = Gtk::manage(new class Gtk::Entry());
   password = Gtk::manage(new class Gtk::Entry());
   
   Gtk::Table *table1 = Gtk::manage(new class Gtk::Table(2, 2, false));
   ok = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-ok")));
   clear = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-clear")));
   
   options=manage(new Gtk::ComboBox());
   lstore = Gtk::ListStore::create(columns);
   options->set_model(lstore);
   
   Gtk::TreeModel::Row row = *(lstore->append());
   
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   
   strcpy(imgfile, id);
   strcat(id, "/icon_login.png");
   Glib::RefPtr<Gdk::Pixbuf> pix_login = Gdk::Pixbuf::create_from_file(imgfile);
   row[columns.icon] = pix_login;
   row[columns.name] = "Login";
   
   strcpy(imgfile, id);
   strcat(id, "/icon_quit.png");
   Glib::RefPtr<Gdk::Pixbuf> pix_quit = Gdk::Pixbuf::create_from_file(imgfile);
   row = *(lstore->append());
   row[columns.icon] = pix_quit;
   row[columns.name] = "Quit";
   
   options->pack_start(columns.icon);
   options->pack_start(columns.name);

   Gtk::HBox *hbox1 = Gtk::manage(new class Gtk::HBox(true, 3));
   Gtk::VBox *vbox1 = Gtk::manage(new class Gtk::VBox(false, 3));

   banner->set_size_request(480,120);
   banner->set_alignment(0.5,0.5);
   banner->set_padding(0,0);
   label1->set_alignment(1,0.5);
   label1->set_padding(0,0);
   label1->set_justify(Gtk::JUSTIFY_LEFT);
   label1->set_line_wrap(false);
   label1->set_use_markup(false);
   label1->set_selectable(false);
   label2->set_alignment(1,0.5);
   label2->set_padding(0,0);
   label2->set_justify(Gtk::JUSTIFY_LEFT);
   label2->set_line_wrap(false);
   label2->set_use_markup(false);
   label2->set_selectable(false);
   logint->set_flags(Gtk::CAN_FOCUS);
   logint->set_visibility(true);
   logint->set_editable(true);
   logint->set_max_length(0);
   logint->set_text(_(""));
   logint->set_has_frame(true);
   logint->set_activates_default(false);
   password->set_flags(Gtk::CAN_FOCUS);
   password->set_visibility(false);
   password->set_editable(true);
   password->set_max_length(0);
   password->set_text(_(""));
   password->set_has_frame(true);
   password->set_activates_default(false);
   table1->set_border_width(3);
   table1->set_row_spacings(3);
   table1->set_col_spacings(3);
   table1->attach(*label1, 0, 1, 0, 1, Gtk::FILL, Gtk::AttachOptions(), 0, 0);
   table1->attach(*label2, 0, 1, 1, 2, Gtk::FILL, Gtk::AttachOptions(), 0, 0);
   table1->attach(*logint, 1, 2, 0, 1, Gtk::EXPAND|Gtk::FILL, Gtk::AttachOptions(), 0, 0);
   table1->attach(*password, 1, 2, 1, 2, Gtk::EXPAND|Gtk::FILL, Gtk::AttachOptions(), 0, 0);
   ok->set_flags(Gtk::CAN_FOCUS);
   ok->set_relief(Gtk::RELIEF_NORMAL);
   clear->set_flags(Gtk::CAN_FOCUS);
   clear->set_relief(Gtk::RELIEF_NORMAL);
   
   //icon_login->set_alignment(0.5,0.5);
   //icon_login->set_padding(0,0);
   
   //image4->set_alignment(0.5,0.5);
   //image4->set_padding(0,0);
   //options->set_flags(Gtk::CAN_FOCUS);
   //options->set_history(0);
   //options->set_menu(*menu1);
   hbox1->set_border_width(3);
   hbox1->pack_start(*ok, Gtk::PACK_SHRINK, 0);
   hbox1->pack_start(*clear, Gtk::PACK_SHRINK, 0);
   hbox1->pack_start(*options, Gtk::PACK_SHRINK, 0);
   vbox1->set_border_width(3);
   vbox1->pack_start(*banner, Gtk::PACK_SHRINK, 0);
   vbox1->pack_start(*table1, Gtk::PACK_SHRINK, 0);
   vbox1->pack_start(*hbox1, Gtk::PACK_SHRINK, 0);
   login->set_events(Gdk::KEY_RELEASE_MASK);
   login->set_border_width(3);
   login->set_title(_("Login"));
   if(bModal) login->set_modal(true);
   else login->set_modal(false);
   login->property_window_position().set_value(Gtk::WIN_POS_CENTER);
   login->set_resizable(false);
   login->property_destroy_with_parent().set_value(false);
   login->add(*vbox1);
   
   show_all();

   //login->signal_changed().connect(sigc::mem_fun(*this, &login_ui::on_login_changed));
   password->signal_changed().connect(sigc::mem_fun(*this, &login_ui::on_password_changed));
   ok->signal_clicked().connect(sigc::mem_fun(*this, &login_ui::on_ok_clicked));
   clear->signal_clicked().connect(sigc::mem_fun(*this, &login_ui::on_clear_clicked));
   //login->signal_activate().connect(sigc::mem_fun(*this, &login_ui::on_login_activate));
   //quit->signal_activate().connect(sigc::mem_fun(*this, &login_ui::on_quit_activate));
   options->signal_changed().connect(sigc::mem_fun(*this, &login_ui::on_options_changed));
   login->signal_delete_event().connect(sigc::mem_fun(*this, &login_ui::on_login_delete_event));
   login->signal_key_release_event().connect(sigc::mem_fun(*this, &login_ui::KeyReleaseEvent));
}

login_ui::~login_ui()
{ 
}
