/*
login_ui.h
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/

#ifndef _LOGIN_UI_H
#define _LOGIN_UI_H

#include <gtkmm/window.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gtkmm/combobox.h>
#include <gtkmm/liststore.h>
#include <cmfengine.h>

class LoginColumns : public Gtk::TreeModel::ColumnRecord
{
public:
   LoginColumns();
   Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > icon;
   Gtk::TreeModelColumn<Glib::ustring> name;
};

class login_ui : public Gtk::Window
{
private:
   virtual void on_login_changed() = 0;
   virtual void on_password_changed() = 0;
   virtual void on_ok_clicked() = 0;
   virtual void on_clear_clicked() = 0;
   virtual void on_login_activate() = 0;
   virtual void on_quit_activate() = 0;
   virtual void on_options_changed() = 0;
   virtual bool on_login_delete_event(GdkEventAny *ev) = 0;
   virtual bool KeyReleaseEvent(GdkEventKey *ev) = 0;
   
protected:
   Glib::RefPtr<Gtk::ListStore> lstore;
   LoginColumns columns;
   class Gtk::Window *login;
   class Gtk::Image  *banner;
   class Gtk::Image  *icon_login;
   class Gtk::Label  *label1;
   class Gtk::Label  *label2;
   class Gtk::Entry  *logint;
   class Gtk::Entry  *password;
   class Gtk::Button *ok;
   class Gtk::Button *clear;
   class Gtk::ComboBox *options;
        
public:
   login_ui(bhmfengine::CMfPosEngine *e);
   ~login_ui();
};

#endif
