/*
mainwin.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include <bhintl.h>
#include "mainwin.h"

mainwin::mainwin(bhmfengine::CMfPosEngine *e) : mainwin_ui(e)
{
   Gdk::Color col;
   
   eng = e;
   
   int  x, y, cdr;
   bool bt;
   
   smartbar_status=BHSB_STATUS_NONE;
   bPluLookup=false;
   timertype=BHTT_NONE;

   eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   eng->GetOption(MFENG_CONFIG_CASHDRESETTLOGIN, &cdr);
   
   statusbar->SetText(bhpos::widget::BHSTATUS_SYSTEM, _("Connected"));
   
   if(bt){
      statusbar->SetText(bhpos::widget::BHSTATUS_USER, _("Login to Start"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Logged Out"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Idle"));
      
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      eng->SetStatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
      SmartBarStatus(BHSB_STATUS_PASSSIVELOGOUT);
   }
   else{
      eng->SetStatus(bhmfengine::MF_STATUS_LOGGEDIN);
      SmartBarStatus(BHSB_STATUS_LOGGEDIN);
   }
   
   col.set_rgb(8704, 31744, 12288);
   statusbar->SetColour(bhpos::widget::BHSTATUS_SYSTEM, Gtk::STATE_INSENSITIVE, col);
   
   eng->signal_system().connect(sigc::mem_fun(*this, &mainwin::SystemMsg));
   eng->signal_transaction().connect(sigc::mem_fun(*this, &mainwin::TransactionMsg));
   eng->signal_pos().connect(sigc::mem_fun(*this, &mainwin::PosMsg));
   
   eng->signal_systemerror().connect(sigc::mem_fun(*this, &mainwin::SystemErrMsg));
   eng->signal_transactionerror().connect(sigc::mem_fun(*this, &mainwin::TransactionErrMsg));
   eng->signal_poserror().connect(sigc::mem_fun(*this, &mainwin::PosErrMsg));
   
   eng->signal_hw().connect(sigc::mem_fun(*this, &mainwin::HardwareMsg));
   //eng->signal_hwerror().connect(sigc::mem_fun(*this, &mainwin::HardwareErrorMsg));
   saleitems->signal_completion().connect(sigc::mem_fun(*this, &mainwin::on_action_done));
   
   //Gtk::Main::signal_key_snooper().connect(sigc::mem_fun(*this, &mainwin::KeySnooperEvent));
   Glib::RefPtr<Gdk::Display> display=Gdk::Display::get_default();
   //if(display) eng->SetDiplay(display);
   
   eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_CLEAR, NULL);
   eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_LINE1, (void *) "VxPOS Retail Lite");
   eng->Command(bhmfengine::BHMF_CMD_HW_CUSTDISP_LINE2, (void *) "Version 2.0.0");
}

void mainwin::on_realize()
{
   /*
   bool b;

   Gtk::Window::on_realize();
   
   eng->GetOption(MFENG_CONFIG_NOMOUSE, &b);
   if(b){
      Glib::RefPtr<Gdk::Pixbuf>  cursor_src;
      //gdk_cursor_new_from_pixmap();
      cursor_src->create_from_inline(0, NULL);
      cursor= new Gdk::Cursor(get_display(), cursor_src, 0, 0);     
      get_window()->set_cursor(*cursor);
   */
}

void mainwin::on_hide()
{
   //g_print("wibblenuts\n");
   show();
}

bool mainwin::on_delete_event(GdkEventAny *event)
{
   return true;
}

bool mainwin::on_focus_out_event(GdkEventFocus *event)
{
   //raise();
   //present();
   grab_focus();
   return true;
}
bool mainwin::on_focus_in_event(GdkEventFocus *ev)
{
   return true;
}

bool mainwin::on_window_state_event(GdkEventWindowState *ev)
{
   bool b;
   
   eng->GetOption(MFENG_CONFIG_NOMINIMIZE, &b);
   
   if(b){
      if(ev->new_window_state==GDK_WINDOW_STATE_ICONIFIED){
         //deiconify();
         return true;
      }
   }
   return false;
}

bool mainwin::Close()
{
   return false;
}

bool mainwin::GeneralTimer()
{
   static int beep=0;
   Gdk::Color col;
   int        x=2;
   
   beep++;
   if(beep==1){
      switch(timertype){
      case BHTT_PAYAMOUNT_ERROR:
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Error"));
         statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Over Amount"));
         col.set_rgb(65535, 0, 0);
         statusbar->SetBackground(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
         statusbar->SetBackground(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
         col.set_rgb(65535, 65535, 65535);
         statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
         statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
         eng->Command(bhmfengine::BHMF_CMD_SYSTEM_BEEP, &x);
         return true;
      }
   }
   else if(beep==2){
      switch(timertype){
      case BHTT_PAYAMOUNT_ERROR:
         statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Amount"));
         statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Tender"));
         col.set_rgb(31744, 8704, 12288);
         statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
         statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
         col.set_rgb(65535, 65535, 65535);
         statusbar->SetBackground(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
         statusbar->SetBackground(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEARPAYAMOUNT, NULL);
         timertype=BHTT_NONE;
         setstatus(bhmfengine::MF_STATUS_TENDER);
         break;
      }
   }
   return false;
}

void mainwin::on_action_done(bhpos::widget::BhCompletionType a, void *d, void *n)
{
   bool   b;
   char   buff[32];
   int    ret;
   double x, y;
   bhpos::CPayItem *pi;
   
   bhmfengine::BhMfStatus status=eng->GetStatus();
   
   switch(a){
   case bhpos::widget::BHITEMLIST_COMPLETION_PLU:   // manual plu done
      updatetrans();
      setstatus(bhmfengine::MF_STATUS_IDLE);
      //statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Ready"));
      //eng->SetStatus(bhmfengine::MF_STATUS_IDLE);
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_QTY:   // quantity done
      //g_print("qty changed\n");
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
      eng->SetStatus(bhmfengine::MF_STATUS_PLUWAIT);
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_DESCEDIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Price"));
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PRICEEDIT:
      //g_print("price edit done...\n");
      eng->Command(bhmfengine::BHMF_CMD_SITEM_ADD_NLU, (bhpos::CSaleItem *) d);
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_INCEDIT:
      ret=eng->Command(bhmfengine::BHMF_CMD_SITEM_EDIT, &CurrPluLookup, (int *) n);
      updatetrans();
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_DECEDIT:
      if(eng->Command(bhmfengine::BHMF_CMD_SITEM_EDIT, (bhpos::CSaleItem *) d, (int *) n)){
         eng->SetStatus(bhmfengine::MF_STATUS_IDLE);
      }
      updatetrans();
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_REMOVE:
      eng->Command(bhmfengine::BHMF_CMD_SITEM_EDIT, (bhpos::CSaleItem *) d, (int *) n);
      updatetrans();
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_CASHITEM:
   {
      int t;
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTIDX, 0, (void *) &t);
      if(t==-1){
         eng->Command(bhmfengine::BHMF_CMD_SITEM_CASHADD, (float *) d);
      }
      else{
         eng->Command(bhmfengine::BHMF_CMD_SITEM_CASHADD, (float *) d);
         updatetrans();
      }
   }
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PAYAMOUNT:
      pi=(bhpos::CPayItem *) d;
      eng->SetStatus(bhmfengine::MF_STATUS_PAYTYPE);
      eng->Command(bhmfengine::BHMF_CMD_PITEM_ADD, pi);
   
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTALTENDERED, 0, &y);
      sprintf(buff, _("%0.2f"), y);
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_TENDERED, buff);
      updatetrans();
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PAYAMOUNTMORE:
      pi=(bhpos::CPayItem *) d;
      eng->SetStatus(bhmfengine::MF_STATUS_PAYTYPE);
      eng->Command(bhmfengine::BHMF_CMD_PITEM_ADD, pi);
   
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTALTENDERED, 0, &y);
      sprintf(buff, _("%0.2f"), y);
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_TENDERED, buff);
      setstatus(bhmfengine::MF_STATUS_TENDER);
      updatetrans();
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PAYCHANGE:
      pi=(bhpos::CPayItem *) d;
      eng->Command(bhmfengine::BHMF_CMD_PITEM_ADD, pi);
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTALTENDERED, 0, &y);
      sprintf(buff, _("%0.2f"), y);
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_TENDERED, buff);
   
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTCHANGE, 0, &y);
      sprintf(buff, _("%0.2f"), y);
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_CHANGE, buff);
   
      updatetrans();
      eng->GetOption(MFENG_CONFIG_CONFIRMPOLICY, &b);
      if(b){
        setstatus(bhmfengine::MF_STATUS_CONFIRMCOMMIT);
      }
      else{ // commit
         setstatus(bhmfengine::MF_STATUS_TRANSCOMMIT);
         eng->Command(bhmfengine::BHMF_CMD_TRANS_COMMIT, NULL);
      }
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PAYBALANCE:
      pi=(bhpos::CPayItem *) d;
      eng->Command(bhmfengine::BHMF_CMD_PITEM_ADD, pi);
      updatetrans();
      if(pi->GetID()==bhpos::PTYPE_CHEQUE){
         setstatus(bhmfengine::MF_STATUS_CHEQUELOADWAIT);
         eng->Command(bhmfengine::BHMF_CMD_HW_PRINTER_CHQLOAD, NULL);
         return;
      }
      else if(pi->GetID()==bhpos::PTYPE_CREDIT){
      }
      else if(pi->GetID()==bhpos::PTYPE_SMARTC){
      }
      // the rest
      eng->GetOption(MFENG_CONFIG_CONFIRMPOLICY, &b);
      if(b){
        setstatus(bhmfengine::MF_STATUS_CONFIRMCOMMIT);
      }
      else{ // commit
         setstatus(bhmfengine::MF_STATUS_TRANSCOMMIT);
         eng->Command(bhmfengine::BHMF_CMD_TRANS_COMMIT, NULL);
      }
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTALTENDERED, 0, &x);
      sprintf(buff, _("%0.2f"), x);
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_TENDERED, buff);
      
      // if cash...
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTAL, 0, &y);
      y=x-y;
      sprintf(buff, _("%0.2f"), y);
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_CHANGE, buff);

      break;

   case bhpos::widget::BHITEMLIST_COMPLETION_PAYERROR:
   {
      // add timer, have fun...
      timertype=BHTT_PAYAMOUNT_ERROR;
      sigc::slot<bool> timer_slot = sigc::mem_fun(*this, &mainwin::GeneralTimer);
      Glib::signal_timeout().connect(timer_slot, 750);
   }
      return;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_TENDER:
      eng->SetStatus(bhmfengine::MF_STATUS_PAYTYPE);
      eng->Command(bhmfengine::BHMF_CMD_PITEM_ADD, (bhpos::CPayItem *) d);
      updatetrans();
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PLUCANCELLED:
      if(status==bhmfengine::MF_STATUS_QUANTITY) break;
      //g_print("mainwin - plu cancellation signal\n");
      saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
      setstatus(bhmfengine::MF_STATUS_IDLE);
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_QTYCANCELLED:
   case bhpos::widget::BHITEMLIST_COMPLETION_DESCEDITCANCELLED:
      saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
      setstatus(bhmfengine::MF_STATUS_IDLE);
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PRICEEDITCANCELLED:
      // check status 
      if(status==bhmfengine::MF_STATUS_PAYTYPE){
         if(saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEARTENDERTYPE, NULL)){
            setstatus(bhmfengine::MF_STATUS_TENDER);
         }
         else{
            setstatus(bhmfengine::MF_STATUS_TENDER);
         }
      }
      else if(status==bhmfengine::MF_STATUS_CASHITEM){
         saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      
      break;
      
   case bhpos::widget::BHITEMLIST_COMPLETION_CASHITEMCANCELLED:
      // remove item...
      saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
      setstatus(bhmfengine::MF_STATUS_IDLE);
      break;
   
   case bhpos::widget::BHITEMLIST_COMPLETION_PAYAMOUNTCANCELLED:
   case bhpos::widget::BHITEMLIST_COMPLETION_PAYBALANCECANCELLED:
   case bhpos::widget::BHITEMLIST_COMPLETION_TENDERCANCELLED:
      //g_print("pay item cancel");
      // remove item...
      //saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_CLEAR, NULL);
      //setstatus(bhmfengine::MF_STATUS_PAYTYPE);
      break;
   }
   
   eng->Command(bhmfengine::BHMF_CMD_SYSTEM_POSTCOMP, NULL);
}

/* extended update from a trans rotation
void mainwin::updatetransrot(bhpos::CTransItems ct)
{
   sprintf(buff, "%012d", *((int *) d));
   transdetail->SetText(bhpos::widget::BHTRANDETAIL_NUMBER, buff);
   updatetrans();
}
*/

void mainwin::updatetrans()
{
   Gdk::Color col;
   int    i=1, j=0;
   double x=0.0, y=0.0;
   char   buff[32];
   bool   bTaxInclusive;
   
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTIDX, 0, &j);
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTNUMITEMS, 0, &i);
   if(i==1){
      sprintf(buff, _("Trans %d : %d item"), j+1, i);
   }
   else{
      sprintf(buff, _("Trans %d : %d items"), j+1, i);
   }
   statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, buff);
      
   // get subtotal
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTSUBTOTAL, 0, &x);
   
   // get tax
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTAX, 0, &y);
   sprintf(buff, _("%0.2f"), y);
   transdetail->SetText(bhpos::widget::BHTRANDETAIL_TAX, buff);
   
   eng->GetOption(MFENG_CONFIG_TAXINCLUSIVE, &bTaxInclusive);
   //if(bTaxInclusive){
      //x+=y;
      sprintf(buff, _("%0.2f"), x);
   //}
   transdetail->SetText(bhpos::widget::BHTRANDETAIL_SUBTOTAL, buff);
   
   // get total
   eng->GetTransInfo(bhmfengine::BHTRANSINFO_CURRENTTOTAL, 0, &x);
   
   eng->GetOption(MFENG_CONFIG_RNDTYPE, &i);
   if(i!=bhpos::BHTRANS_ROUND_NONE) sprintf(buff, _("%0.2f (R)"), x);
	else sprintf(buff, _("%0.2f"), x);
   
   transdetail->SetText(bhpos::widget::BHTRANDETAIL_TOTAL, buff);
   if(x < 0.0){
      col.set_rgb(31744, 8704, 8704);
      transdetail->SetColour(bhpos::widget::BHTRANDETAIL_TOTAL, Gtk::STATE_INSENSITIVE, col);
   }
   banner->SetTotal(x);
}

void mainwin::cleartrans()
{
   Gdk::Color col;
   bool bt;
   
   smartbar_status=BHSB_STATUS_NONE;
   bPluLookup=false;
   
   //statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, "Idle");
   //statusbar->SetText(bhpos::widget::BHSTATUS_MODE, "Ready");
   //col.set_rgb(8704, 31744, 12288);
   //statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
   saleitems->Clear();
   transdetail->Clear();
   banner->SetTotal(0.0);
   setstatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
   SmartBarStatus(BHSB_STATUS_PASSSIVELOGOUT);
}

void mainwin::logout()
{
   Gdk::Color col;
   bool bt;
   
   smartbar_status=BHSB_STATUS_NONE;
   bPluLookup=false;

   eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
      
   if(bt){
      setstatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
   }
   else{
      // kill mainwin, and show login screen.
      //eng->SetStatus(bhmfengine::MF_STATUS_LOGGEDIN);
      //SmartBarStatus(BHSB_STATUS_LOGGEDIN);
   }
}

void mainwin::transcomplete()
{
   Gdk::Color col;
   bool   bConfirmCommit;
   
   eng->GetOption(MFENG_CONFIG_CONFIRMCOMMIT, &bConfirmCommit);
   if(bConfirmCommit){
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, "Press Return to Commit");
      col.set_rgb(46678, 666, 666);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_COMMIT);
   }
   else{
   }
}

void mainwin::on_smart_press(bhpos::widget::BhSmartButton b, GdkEventKey *ev)
{
   
   KeyReleaseEvent(ev);
   return;
   switch(b){
   case bhpos::widget::BHSB_CANCEL:
      break;
   
   case bhpos::widget::BHSB_EXIT:
      break;
   
   case bhpos::widget::BHSB_NEWCUST:
   case bhpos::widget::BHSB_FINDCUST:
      break;
   
   case bhpos::widget::BHSB_QUANTITY:
   case bhpos::widget::BHSB_SALEPRICE:
   case bhpos::widget::BHSB_PLULOOKUP:
   case bhpos::widget::BHSB_PAYIN:
   case bhpos::widget::BHSB_PAYOUT:
      break;

   case bhpos::widget::BHSB_INCREMENT:
   case bhpos::widget::BHSB_DECREMENT:
   case bhpos::widget::BHSB_QTYSET:
   case bhpos::widget::BHSB_DELETE:
      break;
   
   case bhpos::widget::BHSB_ALLAMOUNT:
      break;
    
   case bhpos::widget::BHSB_CASH:
   case bhpos::widget::BHSB_CHEQUE:
   case bhpos::widget::BHSB_CHARGE:
   case bhpos::widget::BHSB_CREDIT:
      break;

   case bhpos::widget::BHSB_REMOVE:
   case bhpos::widget::BHSB_TOTAL:
   case bhpos::widget::BHSB_RETURNITEM:
      break;
   }
}

void mainwin::on_numpad_press(bhpos::widget::BhNumPadButton b, int i)
{
   int k;
   
   switch(b){
   case bhpos::widget::BHNUMPAD_0: k=GDK_0; break;
   case bhpos::widget::BHNUMPAD_1: k=GDK_1; break;
   case bhpos::widget::BHNUMPAD_2: k=GDK_2; break;
   case bhpos::widget::BHNUMPAD_3: k=GDK_3; break;
   case bhpos::widget::BHNUMPAD_4: k=GDK_4; break;
   case bhpos::widget::BHNUMPAD_5: k=GDK_5; break;
   case bhpos::widget::BHNUMPAD_6: k=GDK_6; break;
   case bhpos::widget::BHNUMPAD_7: k=GDK_7; break;
   case bhpos::widget::BHNUMPAD_8: k=GDK_8; break;
   case bhpos::widget::BHNUMPAD_9: k=GDK_9; break;
   case bhpos::widget::BHNUMPAD_DECIMAL: k=GDK_KP_Decimal; break;
   case bhpos::widget::BHNUMPAD_PLUS: k=GDK_plus; break;
   case bhpos::widget::BHNUMPAD_MINUS: k=GDK_minus; break;
   case bhpos::widget::BHNUMPAD_EQUAL: k=GDK_equal; break;
   case bhpos::widget::BHNUMPAD_PGUP: k=GDK_Page_Up; break;
   case bhpos::widget::BHNUMPAD_UP: k=GDK_Up; break;
   case bhpos::widget::BHNUMPAD_DOWN: k=GDK_Down; break;
   case bhpos::widget::BHNUMPAD_PGDOWN: k=GDK_Page_Down; break;
   case bhpos::widget::BHNUMPAD_RETURN: k=GDK_Return; break;
   case bhpos::widget::BHNUMPAD_DELETE: k=GDK_Delete; break;
   }
   GdkEventKey e;
   e.keyval=k;
   KeyReleaseEvent(&e);
}

void mainwin::on_plu_entry(int q, Glib::ustring& plu)
{
   //g_print("mainwin::on_plu_entry()...\n");
   CurrPluLookup.SetPLU(plu);
   CurrPluLookup.SetQuantity(q);
   eng->Command(bhmfengine::BHMF_CMD_SITEM_ADD, &CurrPluLookup);
}

void mainwin::setstatus(bhmfengine::BhMfStatus s)
{
   Gdk::Color col;
   
   switch(s){
   case bhmfengine::MF_STATUS_PASSIVELOGOUT:
      statusbar->SetText(bhpos::widget::BHSTATUS_USER, _("Login to Start"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Logged Out"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Idle"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      col.set_rgb(65535, 65535, 65535);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_PASSSIVELOGOUT);
      break;
   
   case bhmfengine::MF_STATUS_LOGGEDIN:
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Ready"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Idle"));
      col.set_rgb(8704, 31744, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      col.set_rgb(8704, 12288, 31744);
      statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_LOGGEDIN);
      break;
   
   case bhmfengine::MF_STATUS_IDLE:
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Ready"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Idle"));
      col.set_rgb(8704, 31744, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_TRANSIDLE);
      break;
   
   case bhmfengine::MF_STATUS_PRICELIST:
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Price List"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Select Price"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PAYOUT:
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Adjustment"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Pay Out"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PAYIN:
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Adjustment"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Pay In"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PAYADJUSTMENT:
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Adjustment"));
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Adjust"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_LOOKUP:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Item Lookup"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Busy..."));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      return;
   
   case bhmfengine::BHMF_EVENT_SITEM_PLUSCAN:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Item Lookup"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Busy..."));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      break;
   
   case bhmfengine::MF_STATUS_QUANTITY:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Quantity"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Quantity Edit"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
      
   case bhmfengine::MF_STATUS_PLUWAIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Item"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("PLU Entry"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PLULOOKUPNA:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("PLU Lookup"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
      
   case bhmfengine::MF_STATUS_SCANREMOVE:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Scan Item"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Remove Item"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_LISTEDIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Select Edit"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Item Edit"));
      SmartBarStatus(BHSB_STATUS_EDITMODE);
      break;
   
   case bhmfengine::MF_STATUS_DESCRIPTIONENTRY:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Description"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Unknown PLU"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PRICEENTRY:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Price"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Unknown PLU"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_CASHITEM:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Price"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Cash Item"));
      eng->SetStatus(bhmfengine::MF_STATUS_CASHITEM);
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_TENDER:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Select Pay Type"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Tender"));
      SmartBarStatus(BHSB_STATUS_PAYMENTMODE);
      break;
   
   case bhmfengine::MF_STATUS_PAYTYPE:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Amount"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PAYAMOUNT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Amount"));
      SmartBarStatus(BHSB_STATUS_CANCEL);
      break;
   
   case bhmfengine::MF_STATUS_PAYEDIT:
      break;
   
   case bhmfengine::MF_STATUS_LOGGOUTACK:
   case bhmfengine::MF_STATUS_VOIDACK:
      break;
   
   case bhmfengine::MF_STATUS_CONFIRMCOMMIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Press Return"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Trans Commit"));
      SmartBarStatus(BHSB_STATUS_COMMIT);
      break;
   
   case bhmfengine::MF_STATUS_PRINTING:
      break;
   
   case bhmfengine::MF_STATUS_CDOPEN:
      break;
   
   case bhmfengine::MF_STATUS_TRANSCOMMIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Trans Commit"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Busy..."));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      break;
   
   case bhmfengine::MF_STATUS_TRANSLIST:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Select a trans"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Trans Select"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      return;
   
   case bhmfengine::MF_STATUS_MAGWAIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Swipe Card"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Credit Payment"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      return;
   
   case bhmfengine::MF_STATUS_SMARTWAIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Card"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Credit Payment"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      return;
   
   case bhmfengine::MF_STATUS_PAYAUTH:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Credit Authorisation"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Busy..."));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      return;
   
   case bhmfengine::MF_STATUS_CHEQUELOADWAIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Insert Cheque"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Cheque Wait"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      break;
   
   case bhmfengine::MF_STATUS_CHEQUEPRNWAIT:
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Printing Cheque"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Cheque Wait"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_USER, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      break;
      
   /*
   case bhmfengine::MF_STATUS_BLINDBALANCEFETCH:
      //set_title(_("Blind Balance"));
   	statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Retrieving Balance"));
      return;*/
   }
   
   eng->SetStatus(s);
}

void mainwin::on_saleitems_row_activated(const Gtk::TreeModel::Path& path, Gtk::TreeViewColumn* column)
{  
}

void mainwin::on_saleitems_row_collapsed(const Gtk::TreeModel::iterator& iter, const Gtk::TreeModel::Path& path)
{  
}

void mainwin::on_saleitems_row_expanded(const Gtk::TreeModel::iterator& iter, const Gtk::TreeModel::Path& path)
{  
}

bool mainwin::on_saleitems_select_all()
{  
   return 0;
}

bool mainwin::on_saleitems_unselect_all()
{  
   return 0;
}

bool mainwin::on_saleitems_button_press_event(GdkEventButton *ev)
{  
   return 0;
}

bool mainwin::on_saleitems_button_release_event(GdkEventButton *ev)
{  
   return 0;
}

bool mainwin::on_saleitems_focus_in_event(GdkEventFocus *ev)
{
   g_print("hello\n");
   //gdk_key_repeat_disable();
   return true;
}

bool mainwin::on_saleitems_focus_out_event(GdkEventFocus *ev)
{
   g_print("goodbye\n");
   //gdk_key_repeat_restore();
   return false;
}

void mainwin::on_saleitems_size_request(bool bollocks)
{
   saleitems->Resize();
}


void mainwin::on_transactionid_changed()
{  
}

void mainwin::on_mainwin_activate_focus()
{  
}

void mainwin::on_mainwin_move_focus(Gtk::DirectionType dirtype)
{
   this->activate_focus();
}

void mainwin::on_mainwin_set_focus()
{  
}

void mainwin::on_mainwin_check_resize()
{
   saleitems->Resize();
}
