/*
mainwin.h
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _MAINWIN_H
#include "mainwin_ui.h"
#define _MAINWIN_H

#include <cmfengine.h>

enum BhSmartBarStatus{
   BHSB_STATUS_NONE=0,
   BHSB_STATUS_CANCEL,
   BHSB_STATUS_CLEAR,
   BHSB_STATUS_PASSSIVELOGOUT,
   BHSB_STATUS_LOGGEDIN,
   BHSB_STATUS_CUSTOMERSALE,
   BHSB_STATUS_TRANSIDLE,
   BHSB_STATUS_EDITMODE,
   BHSB_STATUS_PAYMENTSELECTED,
   BHSB_STATUS_QUANTITY,
   BHSB_STATUS_PLUENTRY,
   BHSB_STATUS_PAYMENTMODE,
   BHSB_STATUS_PAYMENTENTRY,
   BHSB_STATUS_RETRANSID,
   BHSB_STATUS_RETURNS,
   BHSB_STATUS_COMMIT
};

enum BhDialogueStatus{
   BHDB_STATUS_NONE=0,
   BHDB_STATUS_CONERROR,
   BHDB_STATUS_SELLPRICE,
   BHDB_STATUS_SELTAX,
   BHDB_STATUS_CANCELTRANS,
   BHDB_STATUS_PAYIN,
   BHDB_STATUS_PAYOUT,
   BHDB_STATUS_PAYADJUSTMENT,
   BHDB_STATUS_LOGOUT,
   BHDB_STATUS_LOGOUTP,
   BHDB_STATUS_QUIT,
   BHDB_STATUS_LOADCHEQUE,
   BHDB_STATUS_LOADSLIP,
   BHDB_STATUS_PRINTING,
   BHDB_STATUS_CREDITSEIZE,
   BHDB_STATUS_CREDITFAIL,
   BHDB_STATUS_CREDITERROR
};

enum BhTimerType{
   BHTT_NONE=0,
   BHTT_PAYAMOUNT_ERROR,
   BHTT_CASHDRAWER
};

class mainwin : public mainwin_ui
{
private:
   bhmfengine::CMfPosEngine *eng;
   bhpos::CSaleItem          CurrPluLookup;
   BhSmartBarStatus          smartbar_status;
   BhDialogueStatus          dialoguestatus;
   BhTimerType               timertype;
   bool                      bPluLookup;

   //sigc::slot<bool> cdtimer_slot;
   sigc::connection cdtimer_slot;
   sigc::connection timer_slot;

   void on_plu_entry(int q, Glib::ustring& plu);
   void on_action_done(bhpos::widget::BhCompletionType a, void *d, void *n);
   void on_smart_press(bhpos::widget::BhSmartButton b, GdkEventKey *ev);
   void on_numpad_press(bhpos::widget::BhNumPadButton b, int i);

   void on_saleitems_row_activated(const Gtk::TreeModel::Path& path, Gtk::TreeViewColumn* column);
   void on_saleitems_row_collapsed(const Gtk::TreeModel::iterator& iter, const Gtk::TreeModel::Path& path);
   void on_saleitems_row_expanded(const Gtk::TreeModel::iterator& iter, const Gtk::TreeModel::Path& path);
   bool on_saleitems_select_all();
   bool on_saleitems_unselect_all();
   bool on_saleitems_button_press_event(GdkEventButton *ev);
   bool on_saleitems_button_release_event(GdkEventButton *ev);
   bool on_saleitems_focus_in_event(GdkEventFocus *ev);
   bool on_saleitems_focus_out_event(GdkEventFocus *ev);
   void on_saleitems_size_request(bool bRedraw);
   void on_transactionid_changed();
   void on_mainwin_activate_focus();
   void on_mainwin_move_focus(Gtk::DirectionType);
   void on_mainwin_set_focus();
   void on_mainwin_check_resize();
   bool on_delete_event(GdkEventAny* event);
   bool on_focus_out_event(GdkEventFocus *event);
   bool on_focus_in_event(GdkEventFocus *ev);
   bool on_window_state_event(GdkEventWindowState *ev);
   
   void on_msgbox_event(int);
   void on_paybox_event(int event, float a);
   void on_selbox_event(int event, void *);
   
   bool KeyShift(GdkEventKey *ev);
   bool KeyControl(GdkEventKey *ev);

protected:
   virtual void on_realize();
   void on_hide();
   //int  KeySnooperEvent(Gtk::Widget *widget, GdkEventAny *event);
   bool Close();
   void SystemMsg(int e, void *d);
   void TransactionMsg(int e, void *d);
   void PosMsg(int e, void *d);
   void SystemErrMsg(int e, void *d);
   void HardwareMsg(int e, void *d);
   void HardwareErrorMsg(int e, void *d);
   void TransactionErrMsg(int e, void *d);
   void PosErrMsg(int e, void *d);
   int  SmartBarStatus(BhSmartBarStatus s);
   void updatetrans();
   void transcomplete();
   void cleartrans();
   void setstatus(bhmfengine::BhMfStatus s);
   void logout();

   bool LoginRefuseTimer();
   bool CashDrawerTimer();
   bool GeneralTimer();
   bool SSTTimer();

   bool KeyReleaseEvent(GdkEventKey *ev);
   bool KeyNavigationEvent(GdkEventKey *ev, bhmfengine::BhMfStatus status);
   
public:
   mainwin(bhmfengine::CMfPosEngine *e);
};
#endif
