/*
mainwin_ui.cpp
Copyright (C) 2004 Al Kingsley

Part of:
	VxPos, Copyright (C) 2001-2004 Al Kingsley
	VxPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include <bhintl.h>
#include "mainwin_ui.h"
#include <gtk/gtk.h>
#include <gtkmm/accelgroup.h>
#include <gtkmm/image.h>
#include <gtkmm/box.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/label.h>

mainwin_ui::mainwin_ui(bhmfengine::CMfPosEngine *eng) : Gtk::Window(Gtk::WINDOW_TOPLEVEL)
{  
   mainwin = this;
   
   char id[255];
   char imd[255], a[255], b[255], c[255], d[255];
   bool bModal, bnumpad;
   int  x,y,num_mh, num_mi, i, j;
   int (*kc)(GdkEventKey *);
   BhMenuHeading mh;
   BhMenuItem    mi;
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   eng->GetOption(MFENG_CONFIG_KEYREDIRECTION, &kc);
   
   banner = Gtk::manage(new class bhpos::widget::BhBanner(id));

   Gtk::HBox *hbox2 = Gtk::manage(new class Gtk::HBox(false, 3));
   
   Gtk::ScrolledWindow *scrolledwindow = Gtk::manage(new class Gtk::ScrolledWindow());
   
   eng->GetOption(MFENG_CONFIG_KEYPAD, &bnumpad);
   if(bnumpad)
      transdetail=Gtk::manage(new class bhpos::widget::BhTransDetail(bnumpad, id));
   else
      transdetail=Gtk::manage(new class bhpos::widget::BhTransDetail());
         
   eng->GetOption(MFENG_CONFIG_MODAL, &bModal);
   statusbar=Gtk::manage(new class bhpos::widget::BhStatus());
   
   Gtk::VBox *vbox2 = Gtk::manage(new class Gtk::VBox(false, 3));
   Gtk::HBox *hbox3 = Gtk::manage(new class Gtk::HBox(false, 3));
   
   Gtk::HBox *hbox1 = Gtk::manage(new class Gtk::HBox(false, 3));
   Gtk::VBox *vbox1 = Gtk::manage(new class Gtk::VBox(false, 0));
      
   scrolledwindow->set_flags(Gtk::CAN_FOCUS);
   scrolledwindow->set_shadow_type(Gtk::SHADOW_ETCHED_OUT);
   scrolledwindow->set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC);
   scrolledwindow->property_window_placement().set_value(Gtk::CORNER_TOP_LEFT);
   
   saleitems = Gtk::manage(new class bhpos::widget::BhItemList(scrolledwindow));
   saleitems->set_flags(Gtk::CAN_FOCUS);
   saleitems->set_headers_visible(true);
   saleitems->set_rules_hint(false);
   saleitems->set_reorderable(false);
   saleitems->set_enable_search(true);

   scrolledwindow->add(*saleitems);
   i=0;
   eng->GetOption(MFENG_CONFIG_SMARTBAR, &i);
   if(i!=0){
      bhpos::widget::BhSmartBarType nobber=bhpos::widget::BHSMARTBARTYPE_LABELIMAGE;
      j=0;
      eng->GetOption(MFENG_CONFIG_SMARTBARTYPE, &j);
      switch(j){
      case 1: nobber=bhpos::widget::BHSMARTBARTYPE_LABEL; break;
      case 2: nobber=bhpos::widget::BHSMARTBARTYPE_IMAGE; break;
      case 3: nobber=bhpos::widget::BHSMARTBARTYPE_LABELIMAGE; break;
      case 4: nobber=bhpos::widget::BHSMARTBARTYPE_LABELIMAGEKEY; break;
      }
      //nobber=bhpos::widget::BHSMARTBARTYPE_LABELIMAGE;
      /*
      if(i > 2)
         smartbar=new bhpos::widget::BhSmartBar(Gtk::ORIENTATION_VERTICAL, nobber);
      else
         smartbar=new bhpos::widget::BhSmartBar(Gtk::ORIENTATION_HORIZONTAL, nobber);
      */
      if(i > 2)
         smartbar=new bhpos::widget::BhSmartBar(Gtk::BUTTONBOX_START, nobber);
      else
         smartbar=new bhpos::widget::BhSmartBar(Gtk::BUTTONBOX_START, nobber);
      smartbar->set_size_request(1024, 96);
      //Gtk::Requisition req(1024, 96);
      
   }
   
   hbox3->set_border_width(3);
   if(i==3){
      vbox1->pack_start(*smartbar, Gtk::PACK_SHRINK, 3);
   }
   hbox3->pack_start(*scrolledwindow);
   hbox3->pack_start(*transdetail, Gtk::PACK_SHRINK, 3);
   if(i==4){
      vbox1->pack_start(*smartbar, Gtk::PACK_SHRINK, 3);
   }
   vbox1->pack_start(*banner, Gtk::PACK_SHRINK, 3);
   if(i==1){
      vbox1->pack_start(*smartbar, Gtk::PACK_SHRINK, 3);
   }
   vbox1->pack_start(*hbox3, Gtk::PACK_EXPAND_WIDGET, 3);
   if(i==2){
      vbox1->pack_start(*smartbar, Gtk::PACK_SHRINK, 3);
   }
   vbox1->pack_start(*statusbar, Gtk::PACK_SHRINK, 3);
   mainwin->set_events(Gdk::KEY_PRESS_MASK | Gdk::KEY_RELEASE_MASK);
   mainwin->set_title(_("Sale"));
   eng->GetOption(MFENG_CONFIG_DISP_XSIZE, &x);
   eng->GetOption(MFENG_CONFIG_DISP_YSIZE, &y);
   mainwin->set_size_request(x, y);
   
   mainwin->set_keep_above(bModal);
   eng->GetOption(MFENG_CONFIG_DECORATED, &bModal);
   mainwin->set_decorated(bModal);
   eng->GetOption(MFENG_CONFIG_STICK, &bModal);
   if(bModal) mainwin->stick();
      
   mainwin->property_window_position().set_value(Gtk::WIN_POS_CENTER);
   mainwin->set_resizable(true);
   mainwin->property_destroy_with_parent().set_value(false);
   mainwin->add(*vbox1);

   if(i!=0 && smartbar){
      smartbar->show();
   }
   show_all();
   saleitems->signal_pluentry().connect(sigc::mem_fun(*this, &mainwin_ui::on_plu_entry));
   if(i!=0  && smartbar)
      smartbar->signal_keypress().connect(sigc::mem_fun(*this, &mainwin_ui::on_smart_press));
   if(bnumpad)
      transdetail->signal_keypress().connect(sigc::mem_fun(*this, &mainwin_ui::on_numpad_press));

   saleitems->signal_size_request().connect(sigc::mem_fun(*this, &mainwin_ui::on_saleitems_size_request), false);
   /*
   saleitems->signal_row_activated().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_row_activated));
   saleitems->signal_row_collapsed().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_row_collapsed));
   saleitems->signal_row_expanded().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_row_expanded));
   saleitems->signal_select_all().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_select_all));
   saleitems->signal_unselect_all().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_unselect_all));
   saleitems->signal_button_press_event().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_button_press_event));
   saleitems->signal_button_release_event().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_button_release_event));
   saleitems->signal_focus_in_event().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_focus_in_event));
   saleitems->signal_focus_out_event().connect(sigc::slot(*this, &mainwin_ui::on_saleitems_focus_out_event));
   transactionid->signal_changed().connect(sigc::slot(*this, &mainwin_ui::on_transactionid_changed));*/
   //mainwin->signal_activate_focus().connect(sigc::mem_fun(*this, &mainwin_ui::on_mainwin_activate_focus));
   mainwin->signal_key_release_event().connect(sigc::mem_fun(*this, &mainwin_ui::KeyReleaseEvent));
   //mainwin->signal_move_focus().connect(sigc::slot(*this, &mainwin_ui::on_mainwin_move_focus));
   //mainwin->signal_set_focus().connect(sigc::slot(*this, &mainwin_ui::on_mainwin_set_focus));
   
   /* bum connect...
   mainwin->signal_check_resize().connect(sigc::mem_fun(*this, &mainwin_ui::on_mainwin_check_resize));
   */
   
   eng->GetOption(MFENG_CONFIG_NOCLOSE, &bModal);
   if(bModal)
      mainwin->signal_delete_event().connect(sigc::mem_fun(*this, &mainwin_ui::on_delete_event));
   eng->GetOption(MFENG_CONFIG_NOMINIMIZE, &bModal);
   
   mainwin->signal_focus_in_event().connect(sigc::mem_fun(*this, &mainwin_ui::on_focus_in_event));
   mainwin->signal_focus_out_event().connect(sigc::mem_fun(*this, &mainwin_ui::on_focus_out_event));
   mainwin->signal_window_state_event().connect(sigc::mem_fun(*this, &mainwin_ui::on_window_state_event));
   //mainwin->signal_hide().connect(sigc::mem_fun(*this, &mainwin_ui::on_hide));
}

mainwin_ui::~mainwin_ui()
{  
}

void mainwin_ui::on_realize()
{
   bool b;

   Gtk::Window::on_realize();
   
   gchar bits[] = { 0 };
   GdkColor color = { 0, 0, 0, 0 };
   GdkPixmap *pixmap;
   GdkCursor *cursor;

//   eng->GetOption(MFENG_CONFIG_NOMOUSE, &b);
//   if(b){
      GdkWindow* window=get_window()->gobj();
      pixmap = gdk_bitmap_create_from_data(NULL, bits, 1, 1);
      cursor = gdk_cursor_new_from_pixmap(pixmap, pixmap, &color, &color, 0, 0);
      gdk_window_set_cursor(window, cursor);
//   }
}

void mainwin_ui::on_hide()
{
   g_print("wibblenuts\n");
   show();
}
