/*
mainwin_ui.h
Copyright (C) 2004 Al Kingsley

Part of:
	VxPos, Copyright (C) 2004 Al Kingsley
	VxPos comes with ABSOLUTELY NO WARRANTY. 
*/

#ifndef _MAINWIN_UI_H
#define _MAINWIN_UI_H

#include <gtkmm/main.h>
#include <gdkmm/cursor.h>
#include <gdkmm/display.h>
#include <gtkmm/window.h>
#include <gtkmm/treeview.h>
#include <gtkmm/entry.h>
#include <gtkmm/image.h>
#include <cmfengine.h>
#include <bhbanner.h>
#include <bhsmartbutton.h>
#include <bhsmartbar.h>
#include <bhstatus.h>
#include <bhtransdetail.h>
#include <bhitemlist.h>

class mainwin_ui : public Gtk::Window
{
private:
   virtual void on_plu_entry(int q, Glib::ustring& plu) = 0;
   virtual void on_action_done(bhpos::widget::BhCompletionType a, void *d, void *) = 0;
   virtual void on_smart_press(bhpos::widget::BhSmartButton b, GdkEventKey *ev) = 0;
   virtual void on_numpad_press(bhpos::widget::BhNumPadButton b, int i) = 0;

   virtual void on_saleitems_row_activated(const Gtk::TreeModel::Path& path, Gtk::TreeViewColumn* column) = 0;
   virtual void on_saleitems_row_collapsed(const Gtk::TreeModel::iterator& iter, const Gtk::TreeModel::Path& path) = 0;
   virtual void on_saleitems_row_expanded(const Gtk::TreeModel::iterator& iter, const Gtk::TreeModel::Path& path) = 0;
   virtual bool on_saleitems_select_all() = 0;
   virtual bool on_saleitems_unselect_all() = 0;
   virtual bool on_saleitems_button_press_event(GdkEventButton *ev) = 0;
   virtual bool on_saleitems_button_release_event(GdkEventButton *ev) = 0;
   virtual bool on_saleitems_focus_in_event(GdkEventFocus *ev) = 0;
   virtual bool on_saleitems_focus_out_event(GdkEventFocus *ev) = 0;
   virtual void on_saleitems_size_request(bool bRedraw)=0;
   virtual void on_transactionid_changed() = 0;
   virtual void on_mainwin_activate_focus() = 0;
   virtual void on_mainwin_move_focus(Gtk::DirectionType) = 0;
   virtual void on_mainwin_set_focus() = 0;
   virtual void on_mainwin_check_resize() = 0;
   virtual bool KeyReleaseEvent(GdkEventKey *ev) = 0;
   virtual bool on_delete_event(GdkEventAny *ev) = 0;
   virtual bool on_focus_out_event(GdkEventFocus *event) = 0;
   virtual bool on_focus_in_event(GdkEventFocus *ev) = 0;
   virtual bool on_window_state_event(GdkEventWindowState *ev) = 0;

protected:
   class Gdk::Cursor                  *cursor;
   class Gtk::Window                  *mainwin;
   class bhpos::widget::BhBanner      *banner;
   class bhpos::widget::BhSmartBar    *smartbar;
   class bhpos::widget::BhStatus      *statusbar;
   class bhpos::widget::BhTransDetail *transdetail;
   class bhpos::widget::BhItemList    *saleitems;

   virtual void on_realize();
   virtual void on_hide();
   
public:
   mainwin_ui(bhmfengine::CMfPosEngine *eng);
   ~mainwin_ui();
};

#endif
