/*
splash.cpp
Copyright (C) 2004  Al Kingsley
*/
#include "config.h"
#include "bhintl.h"
#include <gtkmm/main.h>
#include <pos.h>
#include "splash.h"
#include "login.h"
#include "mainwin.h"
#include <bhmsgbox.h>
//#include "confirm.h"

extern splash	*splash_window;
extern mainwin *main_win;
extern bhpos::widget::bhmsgbox *msgbox;

void timeout_yes()
{
	splash_window->show();
	splash_window->conn();
}

void quit_yes()
{
   //splash_window->Close();
	//if(Close()) Gtk::Main::quit();
}

void timeout_no()
{
   /*
   char          id[255];
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   
   strcat(id, "/unhappy_banana.png");
   manage(new class bhmsgbox(BHCONFIRMBOX_OK, bm, _("Quit BananaPOS"),
	   id, _("So you really want to quit?"), &err_yes, &err_no));*/
}

void splash::on_msgbox_event(int event)
{
   if(event){
      conn();
   }
   else{
      hide();
      Gtk::Main::quit();
   }
}

void splash::EngMsg(int type, void *data)
{
   char          cbuff[32];
   Glib::ustring text;
   
   if(!bConnect) return;
   
   switch(type){
   case bhmfengine::BHMF_EVENT_CONNECT:
      current=1;
      imagetick(1);
      eng->Command(bhmfengine::BHMF_CMD_PRINTERSETTINGS, NULL);
      break;
   
   case bhmfengine::BHMF_EVENT_PRINTERSETTINGS:
   {
      int c=*((int *) data);
      if(c==0){ // done
         current=2;
         imagetick(2);
         sys_connect_progress->set_text(_("Loading Prefix List..."));
         eng->Command(bhmfengine::BHMF_CMD_PREFIXLIST, NULL);
         return;
      }
      sprintf(cbuff, _("Loading Printer Setting: %d"), c);
      text=cbuff;
      sys_connect_progress->set_text(text);
      t++;
	   f=(gfloat) t/100;
	   sys_connect_progress->set_fraction(f);
      break;
   }
   
   case bhmfengine::BHMF_EVENT_PREFIXLIST:
      current=3;
      t++;
	   f=(gfloat) t/100;
	   sys_connect_progress->set_fraction(f);
      imagetick(3);
      sys_connect_progress->set_text(_("Loading Tax List..."));
      eng->Command(bhmfengine::BHMF_CMD_TAXLIST, NULL);
      break;
   
   case bhmfengine::BHMF_EVENT_TAXLIST:
      t++;
	   f=(gfloat) t/100;
	   sys_connect_progress->set_fraction(f);
      sys_connect_progress->set_text(_("Loading Price List..."));
      eng->Command(bhmfengine::BHMF_CMD_PRICELIST, NULL);
      break;
   
   case bhmfengine::BHMF_EVENT_PRICELIST:
      t++;
	   f=(gfloat) t/100;
	   sys_connect_progress->set_fraction(f);
      sys_connect_progress->set_text(_("Loading Payment Types..."));
      eng->Command(bhmfengine::BHMF_CMD_PAYLIST, NULL);
      return;
   
   case bhmfengine::BHMF_EVENT_PAYLIST:
      current=4;
      t++;
	   f=(gfloat) t/100;
      imagetick(4);
      sys_connect_progress->set_text(_("Setting Up Hardware..."));
      eng->Command(bhmfengine::BHMF_CMD_HARDWARE, NULL);
      return;
   
   case bhmfengine::BHMF_EVENT_HARDWARE:
   {
      bool bt=true;
      /*
      current=5;
      t++;
	   f=(gfloat) t/100;
      imagetick(5);*/
      
      eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
      // we're done, disappear the splash, invoke the mainwin
      con.disconnect();
      this->destroy_();
   
      if(bt){
         eng->SetStatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
     		main_win=new mainwin(eng);
      }
  		else{
         eng->SetStatus(bhmfengine::MF_STATUS_LOGGEDOUT);
         manage(new class login(eng));
  		   //li=new class login(eng);
      }
   }
      break;
   }
}

void splash::EngErrMsg(int type, void *data)
{
   char          id[255];
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
      
   if(con.connected()){
      g_print("connected...\n");
      bConnect=false;
      con.disconnect();
   }
   
   current_status=type;
   
   switch(type){
   case bhmfengine::BHMF_EVENT_CONNECT:
      strcat(id, "/icon_conerror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_CLOSE, _("Connection Error"),id, _("Connection Refused")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
      
    case bhmfengine::BHMF_EVENT_PRINTERSETTINGS:
      strcat(id, "/icon_printerror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("System Error"),id, _("Printer Settings Download")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
   
   
   case bhmfengine::BHMF_EVENT_PREFIXLIST:
      strcat(id, "/icon_listerror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("System Error"),id, _("Prefix List Download")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
   
   case bhmfengine::BHMF_EVENT_TAXLIST:
      strcat(id, "/icon_listerror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("System Error"),id, _("Tax List Download")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
   
   case bhmfengine::BHMF_EVENT_PRICELIST:
      strcat(id, "/icon_listerror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("System Error"),id, _("Price List Download")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
   
   case bhmfengine::BHMF_EVENT_PAYLIST:
      strcat(id, "/icon_listerror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("System Error"),id, _("Pay Types Download")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
   
   case bhmfengine::BHMF_EVENT_HARDWARE:
      strcat(id, "/icon_harderror.png");
      msgbox=manage(new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("System Error"),id, _("Hardware Setup")));
      msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
      break;
   }
}

splash::splash(bhmfengine::CMfPosEngine *engine) : splash_ui()
{
   char id[255];
   
   eng=engine;
   bLeft=true;
   current=0;
   menuid=0;
   current_status=0;
   bConnect=false;
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/splash.png");
   
   image = Gdk::Pixbuf::create_from_file(id);
   eng->signal_system().connect(sigc::mem_fun(*this, &splash::EngMsg));
   eng->signal_systemerror().connect(sigc::mem_fun(*this, &splash::EngErrMsg));
   
	conn();	
}

splash::~splash()
{
	con.disconnect();
}

void splash::on_sys_connect_cancel_clicked()
{
   char id[255];
   bool b;
   eng->GetOption(MFENG_CONFIG_MODAL, &b);
   
   con.disconnect();
   this->hide();
   /*
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/unhappy_banana.png");
   
   manage(new class bhmsgbox(BHCONFIRMBOX_OK, bm, _("Quit BananaPOS"),
		   id, _("Do you really want to quit?), &err_yes, &err_no));*/
}

bool splash::on_expose_event(GdkEventExpose* ev)
{
   gc = Gdk::GC::create(drawingarea->get_window());
   drawingarea->get_window()->draw_pixbuf(gc, image, 0, 0, 0, 0, image->get_width(), image->get_height(), Gdk::RGB_DITHER_NONE, 0, 0);
   
   return true;
}

void splash::Close()
{
   con.disconnect();
   this->destroy_();
}

bool splash::updater()
{
   bool b;
   char cbuff[32];
   Glib::ustring text;
      
	t++;
	f=(gfloat) t/100;
	sys_connect_progress->set_fraction(f);
	if(current==0){
   	if(t>=20){
	   	t=0;
		   r++;
         bConnect=true;
         sprintf(cbuff, _("Connection Attempt %d"), r+1);
         text=cbuff;
         sys_connect_progress->set_text(text);
         if(bLeft){
            bLeft=false;
         }
         else{
            bLeft=true;
         }
	   	if(r==10){
		   	if(bConnect){
			   	con.disconnect();
				   this->hide();
               char          id[255];
   
               strcpy(id, "");
               eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
               strcat(id, "/icon_conerror.png");
               current_status=-1;
               msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_RETRYQUIT, _("Connection Error"),id, _("Connection Timed Out"));
               msgbox->signal_event().connect(sigc::mem_fun(*this, &splash::on_msgbox_event));
   			}
	   		else{
		   		r=0;
			   	return true;
			   }
   			return false;
	   	}
         eng->Command(bhmfengine::BHMF_CMD_CONNECT, NULL);
      }
      else{
         if(current==1) return false;
	   }
   }
	return true;
}

void splash::conn()
{
	t=0;
	r=0;
   sys_connect_progress->set_text(_("Connection Attempt 1..."));
   current=0;
   con=Glib::signal_timeout().connect(sigc::mem_fun(*this, &splash::updater), 100);
   show();
   queue_draw();
}

void splash::imagetick(int i)
{
   char id[255];
   Glib::RefPtr<Gdk::Pixbuf> icon1;
   Glib::RefPtr<Gdk::Pixbuf> icon2;
   Glib::RefPtr<Gdk::Pixbuf> icon3;
   Glib::RefPtr<Gdk::Pixbuf> icon4;
   Glib::RefPtr<Gdk::Pixbuf> icon5;
   
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/splash_icon1.png");
   icon1 = Gdk::Pixbuf::create_from_file(id);
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/splash_icon2.png");
   icon2 = Gdk::Pixbuf::create_from_file(id);
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/splash_icon3.png");
   icon3 = Gdk::Pixbuf::create_from_file(id);
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/splash_icon4.png");
   icon4 = Gdk::Pixbuf::create_from_file(id);
   strcpy(id, "");
   eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
   strcat(id, "/splash_icon5.png");
   icon5 = Gdk::Pixbuf::create_from_file(id);

   gc = Gdk::GC::create(drawingarea->get_window());
   drawingarea->get_window()->draw_pixbuf(gc, image, 0, 0, 0, 0, image->get_width(), image->get_height(), Gdk::RGB_DITHER_NONE, 0, 0);

   switch(i){
   case 1:
      drawingarea->get_window()->draw_pixbuf(gc, icon1, 0, 0, 32, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      break;
   case 2:
      drawingarea->get_window()->draw_pixbuf(gc, icon1, 0, 0, 32, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon2, 0, 0, 128, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      break;
   
   case 3:
      drawingarea->get_window()->draw_pixbuf(gc, icon1, 0, 0, 32, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon2, 0, 0, 128, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon3, 0, 0, 224, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      break;
      
   case 4:
      drawingarea->get_window()->draw_pixbuf(gc, icon1, 0, 0, 32, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon2, 0, 0, 128, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon3, 0, 0, 224, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon4, 0, 0, 320, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      break;

   case 5:
      drawingarea->get_window()->draw_pixbuf(gc, icon1, 0, 0, 32, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon2, 0, 0, 128, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon3, 0, 0, 224, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon4, 0, 0, 320, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      drawingarea->get_window()->draw_pixbuf(gc, icon5, 0, 0, 416, 236, 48, 48, Gdk::RGB_DITHER_NONE, 0, 0);
      break;
   }
}

gint splash::connector_deleteevent(GdkEventAny *ev)
{
   return 1;
}
