/*
transaction.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include "bhintl.h"
#include "mainwin.h"
#include <bhmsgbox.h>

extern bhpos::widget::bhmsgbox *msgbox;

bool mainwin::CashDrawerTimer()
{
   static int beep=0;
   Gdk::Color col;
   int        x=2;
   
   beep++;
   if(beep==1){
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Close Cash Drawer"));
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Transaction End"));
      col.set_rgb(65535, 0, 0);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      col.set_rgb(65535, 65535, 65535);
      statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      eng->Command(bhmfengine::BHMF_CMD_SYSTEM_BEEP, &x);
   }
   else if(beep==2){
      statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Close Cash Drawer"));
      col.set_rgb(31744, 8704, 12288);
      statusbar->SetColour(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      col.set_rgb(65535, 65535, 65535);
      statusbar->SetBackground(bhpos::widget::BHSTATUS_STATUS, Gtk::STATE_INSENSITIVE, col);
      beep=0;
   }
   return true;
}

void mainwin::TransactionMsg(int e, void *d)
{
   int  n;
   char buff[32];
   Gdk::Color col;
   bool bt;
   
   eng->GetOption(MFENG_CONFIG_LOGOUTEACHTRANS, &bt);
   col.set_rgb(31744, 8704, 8704);
   
   switch(e){
   case bhmfengine::BHMF_EVENT_TRANS_ID:
   {
      int    num_trans;
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMTRANS, 0, &num_trans);
      if(num_trans==0){
         sprintf(buff, _("Sale - No Open Transactions"));
      }
      else if(num_trans==1){
         sprintf(buff, _("Sale - 1 Open Transaction"));
      }
      else{
         sprintf(buff, _("Sale - %d Open Transactions"), num_trans);
      }
      set_title(buff);
      
      sprintf(buff, "%012d", *((int *) d));
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_NUMBER, buff);
   }
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_IDADD:
   {
      int    num_trans;
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMTRANS, 0, &num_trans);
      if(num_trans==0){
         sprintf(buff, _("Sale - No Open Transactions"));
      }
      else if(num_trans==1){
         sprintf(buff, _("Sale - 1 Open Transaction"));
      }
      else{
         sprintf(buff, _("Sale - %d Open Transactions"), num_trans);
      }
      set_title(buff);
      
      sprintf(buff, "%012d", *((int *) d));
      transdetail->SetText(bhpos::widget::BHTRANDETAIL_NUMBER, buff);
      updatetrans();
   }
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_CYCLE:
      n=*((int *) d);
      if(n==0){
         // cycle to a blank
         cleartrans();
      }
      else if(n > 0){
         bhpos::CTransItems ct;
         eng->TransCycle(ct);
         saleitems->Load(ct);
         updatetrans();
      }
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_LIST:
   {
      // server returned a list of open transactions
      // display them
      BhSSTransList *tl=(BhSSTransList *) d;
   }
      break;
   
   case bhmfengine::BHMF_EVENT_IDLE:
      setstatus(bhmfengine::MF_STATUS_IDLE);
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_UPDATE:
      updatetrans();
      setstatus(bhmfengine::MF_STATUS_IDLE);
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_LOOKUP:
      setstatus(bhmfengine::MF_STATUS_PLULOOKUP);
      return;
   
   case bhmfengine::BHMF_EVENT_SITEM_PLUSCAN:
   {
      Glib::ustring plu=*((Glib::ustring *) d);
      saleitems->Action(bhpos::widget::BHITEMLIST_ACTION_SCANPLU, &plu);
      saleitems->Get(&n);
      //n=1;
      CurrPluLookup.SetPLU(plu);
      CurrPluLookup.SetQuantity(n);
      setstatus(bhmfengine::MF_STATUS_PLUSCAN);
      eng->Command(bhmfengine::BHMF_CMD_SITEM_ADD, &CurrPluLookup);
   }
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_RETURN:
      //CurrPluLookup=*((bhpos::CSaleItem *) d);
      if(d==NULL){
         //statusbar->SetText(bhpos::widget::BHSTATUS_MODE, _("Unknown Item"));
         //statusbar->SetText(bhpos::widget::BHSTATUS_STATUS, _("Enter Description"));
         //CurrPluLookup.SetType(bhpos::BHSI_SITYPE_UPLU);
         //saleitems->Add(bhpos::widget::BHITEMLIST_ITEMFLAG_NONE, &CurrPluLookup);
         return;
      }
      else{
         if(bPluLookup){
            bPluLookup=false;
            saleitems->Add(bhpos::widget::BHITEMLIST_ITEMFLAG_DROPNEXT, (bhpos::CSaleItem *) d);
         }
         else{
            saleitems->Add(bhpos::widget::BHITEMLIST_ITEMFLAG_NONE, (bhpos::CSaleItem *) d);
            if(((bhpos::CSaleItem *) d)->GetType()==bhpos::BHSI_SITYPE_UPLU){
               // get uplu policy...
               //eng->SetStatus(bhmfengine::MF_STATUS_DESCRIPTIONENTRY);
            }
         }
      }
      //statusbar->SetText(bhpos::widget::BHSTATUS_MODE, "Ready");
      //col.set_rgb(8704, 31744, 12288);
      //statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      // get num items to status bar
      //updatetrans();
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_REMOVE:
      saleitems->Remove(*((bhpos::CSaleItem *) d));
      setstatus(bhmfengine::MF_STATUS_IDLE);
      updatetrans();
      break;
   
   case bhmfengine::BHMF_EVENT_SITEM_EDIT:
      saleitems->Edit(*((bhpos::CSaleItem *) d));
      setstatus(bhmfengine::MF_STATUS_IDLE);
      updatetrans();
      break;
   
   case bhmfengine::BHMF_EVENT_PITEM_AUTH:
      setstatus(bhmfengine::MF_STATUS_PAYAUTH);
      break;
   
   case bhmfengine::BHMF_EVENT_PITEM_AUTHRETURN:
   {
      char   id[255];
      BhTransPayAuthReply *r=(BhTransPayAuthReply *) d;
      /*
      transID;
      unsigned char  bAccepted;
      unsigned char  bRequireSupervisor;
      unsigned char  flags;
      char           recText[32];
      char           Reason[1]
      }*/
      if(r->bAccepted){
      }
      else{
         eng->GetOption(MFENG_CONFIG_IMAGEDIR, &id);
         if(r->flags==bhpos::PTYPE_FLAG_CREDITSIEZE){
            dialoguestatus=BHDB_STATUS_CREDITSEIZE;
            strcat(id, "/icon_creditseize.png");
            msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("Credit Authorisation Failure"),id, _("Seize Card"));
            msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
         }
         else if(r->flags==bhpos::PTYPE_FLAG_FAIL){
            dialoguestatus=BHDB_STATUS_CREDITFAIL;
            strcat(id, "/icon_creditfail.png");
            msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_OK, _("Credit Authorisation Failure"),id, _("Authorisation Failed"));
            msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
         }
         else if(r->flags==bhpos::PTYPE_FLAG_ERROR){
            dialoguestatus=BHDB_STATUS_CREDITERROR;
            strcat(id, "/icon_crediterror.png");
            msgbox=new bhpos::widget::bhmsgbox(BHCONFIRMBOX_CANCELRETRY, _("Credit Authorisation Failure"),id, _("Authorisation Error"));
            msgbox->signal_event().connect(sigc::mem_fun(*this, &mainwin::on_msgbox_event));
         }
      }
   }
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_VOID:
      cleartrans();
      if(bt){
         setstatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
      }
      else{
         setstatus(bhmfengine::MF_STATUS_IDLE);
      }
      int    num_trans;
      eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMTRANS, 0, &num_trans);
      if(num_trans==0){
         sprintf(buff, _("Sale - No Open Transactions"));
      }
      else if(num_trans==1){
         sprintf(buff, _("Sale - 1 Open Transaction"));
      }
      else{
         sprintf(buff, _("Sale - %d Open Transactions"), num_trans);
      }
      set_title(buff);
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_COMMIT:
      n=*((int *) d);
      sprintf(buff, "commit:%d", n);
      statusbar->SetText(bhpos::widget::BHSTATUS_MODE, buff);
      col.set_rgb(31744, 12288, 8704);
      statusbar->SetColour(bhpos::widget::BHSTATUS_MODE, Gtk::STATE_INSENSITIVE, col);
      break;
   
   case bhmfengine::BHMF_EVENT_TRANS_END:
   {
      // check on cash drawer open...
      // there a couple of ways to do this:
      // 1) warn on draw open events from the engine
      // 2) fire up a timer, and kill it on drawer closed.
      //
      // using latter for finer grained control.
      // mfengine::transcommit open draw if exists
      if(!eng->Command(bhmfengine::BHMF_CMD_HW_CASHDRAWERTIMER,NULL)){
         sigc::slot<bool> slot = sigc::mem_fun(*this, &mainwin::CashDrawerTimer);
         cdtimer_slot = Glib::signal_timeout().connect(slot, 500);
      }
      else{
         cleartrans();
         if(bt){
            setstatus(bhmfengine::MF_STATUS_PASSIVELOGOUT);
         }
         else{
            setstatus(bhmfengine::MF_STATUS_IDLE);
         }
         int    num_trans;
         eng->GetTransInfo(bhmfengine::BHTRANSINFO_NUMTRANS, 0, &num_trans);
         if(num_trans==0){
            sprintf(buff, _("Sale - No Open Transactions"));
         }
         else if(num_trans==1){
            sprintf(buff, _("Sale - 1 Open Transaction"));
         }
         else{
            sprintf(buff, _("Sale - %d Open Transactions"), num_trans);
         }
         set_title(buff);
      }
   }
      break;
   }
}
