/*
vxretail.cpp
Copyright (C)2004 Al Kingsley

*/
#include <config.h>
#include <gtkmm/main.h>

#include <pos.h>
#include <cmfengine.h>

#include "splash.h"
#include "mainwin.h"

bhmfengine::CMfPosEngine *engine;
splash	                *splash_window;
sigc::connection          initial_conn;
sigc::connection          initial_errconn;
mainwin                  *main_win;

int keycheck(GdkEventKey *)
{
   return 0;
}

void BootEngMsg(int type, void *data)
{
   //int response=*((int *) data);
   switch(type){
   case bhmfengine::BHMF_EVENT_READCONFIG:
      engine->Command(bhmfengine::BHMF_CMD_OPENNET, NULL);
      break;
   
   case bhmfengine::BHMF_EVENT_OPENNET:
      initial_conn.disconnect();
      initial_errconn.disconnect();
      splash_window = new splash(engine);
      break;
   }
}

void BootEngErrMsg(int type, void *data)
{
   //int response=*((int *) data);

   switch(type){
   case bhmfengine::BHMF_EVENT_READCONFIG:
      g_print("read config failed\n");
      exit(0);
      break;
   
   case bhmfengine::BHMF_EVENT_OPENNET:
      g_print("network open failed\n");
      exit(0);
      break;
   }
}

int main(int argc, char **argv)
{
   int  x, y;
   bool bModal;   
   
#if defined(ENABLE_NLS)
   bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
   bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
   textdomain (GETTEXT_PACKAGE);
#endif //ENABLE_NLS
   
   Glib::thread_init();
   //if(!Glib::thread_supported()) Glib::thread_init();
      
   Gtk::Main m(&argc, &argv);
   engine=new bhmfengine::CMfPosEngine(&m);
   if(!engine) return 1;
   initial_conn=engine->signal_system().connect(sigc::ptr_fun(&BootEngMsg));
   initial_errconn=engine->signal_systemerror().connect(sigc::ptr_fun(&BootEngErrMsg));
   
   engine->Command(bhmfengine::BHMF_CMD_READCONFIG, (void *) "/etc/vxpos/vxretail-lite.conf");
   //sleep(1);
   while(gtk_events_pending())
	   gtk_main_iteration();

   m.run();
   
   return 0;
}
